var FN = {};
FN.debug = 0;
//FN.debugUrl = 'http://hangzhoufeiniu.6655.la:14368/';
FN.clickTime = new Date().getTime();

//系统框架方法
FN.ctrl = {
    index: {},
    bt: baidu.template,
    set: function (name, func) {
        this.index[name] = {
            'func': func,
            'ret': null,
            'params': {
                'ctrlName': name,
                'dom': function () {
                    return $('#' + name + '_show')
                }
            }
        }
        return this;
    },
    deviceWidth: document.body.clientWidth,
    viewport: function (name) {
        //适配首页和安全保障用viewport来适配页面的方案
        //具体在FN.page.go里面hide/show中间调用
        if (name == 'recommend' || name == 'security') {

            var deviceWidth = document.body.clientWidth
            if (deviceWidth == FN.ctrl.deviceWidth) {

                var scale = deviceWidth / 750;

                viewport = document.querySelector("meta[name=viewport]");

                viewport.setAttribute('content', 'width=750, initial-scale=' + scale + ', maximum-scale=' + scale + ', minimum-scale=' + scale + ', user-scalable=0,shrink-to-fit=no');

            }
            //动态给上下拉刷新添加样式,因为recommend中用的viewport适配的页面css
            FN.util.scrolladd();
        } else {

            var deviceWidth = document.body.clientWidth,
                scale = 1;
            viewport = document.querySelector("meta[name=viewport]");
            viewport.setAttribute('content', 'width=device-width, initial-scale=' + scale + ', maximum-scale=' + scale + ', minimum-scale=' + scale + ', user-scalable=0,shrink-to-fit=no');

            //移除
            FN.util.scrollremove();

        }

    },
    bannercssios: function (name) {

        if (name == 'recommend' || name == 'security') {
            //动态适配ios顶部banner
            FN.util.banneradd();
        } else {
            //动态适配ios顶部banner
            FN.util.bannerremove();
        }
    },
    get: function (name) {

        if (this.index[name]) {
            this.index[name]['ret']['params'] = this.index[name]['params'];

            return this.index[name]['ret'];
        }
    },
    canDo: function () {
        var now = new Date().getTime();
        if (now - FN.clickTime > 1000) {
            FN.clickTime = now;
            return true;
        }
        return false;
    },
    //核心和callback一样
    show: function (name, data) {

        var html = this.bt(name + '_tpl', data);
        //$('#'+name+'_show').html('<span>aaaa</span>');
        //$('#more_show').html('&nbsp;');
        //$('#more_show').hide();
        //alert(this.bt);
        $('#' + name + '_show').html(html);
        //输出当前Html代码。。。。
        //var yuanma=document.documentElement.outerHTML;
        // alert(yuanma);
        //顶部下拉刷新
        myScroll.refresh();
        //隐藏刷新效果
        FN.ctrl.hideScroller(true, true);

        $('#' + name + '_show').find("[onclick]").each(function () {
            var clickFun = this.onclick;
            this.onclick = function (arguments) {
                FN.ctrl.canDo() && clickFun(arguments);
            };
        });

        //每次show完毕后，要隐藏dialog,避免一直在转动。。
        FN.native.closeWaitDialog();

        //适配ios顶部的banner高度
        //FN.ctrl.bannercssios(name);

    },
    append: function (obj, name, data, str) {

        if (!obj)
            return;
        var html = this.bt(name + '_tpl', data);

        html = html.substring(html.indexOf(str) + str.length, html.lastIndexOf(str));

        obj.append(html);

        myScroll.refresh();
    },
    run: function (name) {
        if (this.index[name] != undefined && this.index[name] != null) {
            this.index[name]['ret'] = this.index[name]['func'](this.index[name]['params']);
        }
    },
    //网络超时和处理数据异常 ，html提示信息。。
    exception: function (data, isPopDialog) {
        $('#data_exception_show').attr('class', 'hide');
        $('#net_exception_show').attr('class', 'hide');
        if (data.error == 11) {
            if ((isPopDialog != undefined && isPopDialog) || $('#' + FN.page.current + '_show').html() != '&nbsp;') { //显示pop错误
                FN.ctrl.afterResponseAction();
                FN.ctrl.tip({
                    'title': '加载出错',
                    'desc': '请稍后再试！'
                });
                return true;
            }
            //显示html错误errorLoad.html
            $('#data_exception_show').removeClass('hide');
            //先隐藏前面html上内容
            $('#' + FN.page.current + '_show').html('&nbsp;');

            FN.ctrl.show('data_exception', data.result);

            FN.native.closeWaitDialog();
            return true;
        } else if (data.error == 22) {
            if ((isPopDialog != undefined && isPopDialog) || $('#' + FN.page.current + '_show').html() != '&nbsp;') { //显示pop错误
                FN.ctrl.afterResponseAction();

                FN.ctrl.tip({
                    'title': '网络异常',
                    'desc': '网络连接不可用！'
                });

                return true;
            }
            //显示html错误errorNet.html
            $('#net_exception_show').removeClass('hide');
            //先隐藏前面html上内容
            $('#' + FN.page.current + '_show').html('&nbsp;');

            FN.ctrl.show('net_exception', data.result);

            FN.native.closeWaitDialog();
            return true;
        }
        return false;
    },
    popupCtrl: function (show) {
        if (show) {
            $("#fnpopup-screen").removeClass('hide');
            $("#myPopupDiv").removeClass('bottomLayer').addClass('topLayer');
            /*var top = window.screen.height - $("#myPopupDiv").height()/2;
             var left = window.screen.with - $("#myPopupDiv").width()/2;
             $("#myPopupDiv").css('top',top);
             $("#myPopupDiv").css('left',left);*/
        } else {
            $("#fnpopup-screen").addClass('hide');
            $("#myPopupDiv").removeClass('topLayer').addClass('bottomLayer');
        }
    },
    tip: function (params) {
        var img = params.img || "./common/img/error_load.png";
        var title = params.title || "加载出错！";
        var desc = params.desc || "请稍后重试";
        var tipDiv = $("#myPopupDiv");
        tipDiv.find('.dia_error_img').attr('src', img);
        tipDiv.find('.dia_error_title').html(title);
        tipDiv.find('.dia_error_desc').html(desc);
        FN.ctrl.popupCtrl(true);
    },
    smallTip: function (value, time) {
        var title = value || "提示";

        if (value.length <= 20) {
            time = 2000;
        } else {
            time = 4000;
        }

        var during = time || 1000;
        var tipDiv = $("#smallTip");
        tipDiv.find('.smallTip').html(title);
        tipDiv.removeClass('hide');
        setTimeout(function () {
            tipDiv.addClass('hide');
        }, during);
    },
    msgTip: function (params) {
        var title = params.title || '消息提示';
        var content = params.content || '请稍后重试';
        var tipDiv = $("#myMsgTipDiv");
        var event = params.event || function () {
                FN.ctrl.msgTipCtrl(false)
            };
        var param = params.param || '';
        var desc = params.desc || '确定';
        tipDiv.find('.msg-tip-title').html(title);
        tipDiv.find('.pd-md').html(content);
        tipDiv.find('.btn-primary').unbind();
        tipDiv.find('.btn-primary').click(function () {

            event(param);

        });
        tipDiv.find('.btn-primary').html(desc);
        FN.ctrl.msgTipCtrl(true);

        // 垂直居中
        var windowHeight = window.screen.height;
        var divHeight = document.getElementById("myMsgTipDiv").offsetHeight;
        var divY = (windowHeight - divHeight) / 2;
        $('#myMsgTipDiv').css("top", divY);
    },
    msgTipCtrl: function (show) {

        if (show) {
            $("#msgtip-screen").removeClass('hide');
            $("#myMsgTipDiv").removeClass('bottomLayer').addClass('bankTopLayer');
        } else {
            $("#msgtip-screen").addClass('hide');
            $("#myMsgTipDiv").removeClass('bankTopLayer').addClass('bottomLayer');
        }
    },
    hideScroller: function (top, bottom) {
        if (top)
            $(pullDownEl).hide();
        if (bottom)
            $(pullUpEl).hide();
    },
    showScroller: function (top, bottom) {
        if (top) {
            if ($(pullDownEl).is(':hidden'))
                $(pullDownEl).show();
            pullDownEl.className = 'loading';
            pullDownEl.querySelector('.pullDownLabel').innerHTML = '加载中...';
        }
        if (bottom) {
            if ($(pullUpEl).is(':hidden'))
                $(pullUpEl).show();
            pullUpEl.className = 'loading';
            pullUpEl.querySelector('.pullDownLabel').innerHTML = '加载中...';
        }
    },
    afterResponseAction: function () {
        FN.native.closeWaitDialog();
        myScroll.refresh();
        FN.ctrl.hideScroller(true, true);
    },
    gotoSpecific: function (data) {
        if (data.type == 1) {
            FN.page.go('recommend');
        } else if (data.type == 2) {
            FN.page.go('productDetail', {
                'id': data.content,
                'name': '产品详情',
                'goBackUrl': 'recommend'
            }, 'load');
        } else if (data.type == 3) {
            FN.page.go('productList');
        } else if (data.type == 4) {
            if (!window.local_obj) {
                ios_pushGOToMyInvest();
            } else {
                FN.page.go('myInvest');
            }
        } else if (data.type == 5) {
            FN.page.go('more');
        }
        //else if(data.type == 6){
        //FN.page.go('aboutMe');//123
        //}

    },
    confirmCtrl: function (isShow) {
        if (isShow) {
            $("#confirm-screen").removeClass('hide');
            $("#myConfirmDiv").removeClass('bottomLayer').addClass('bankTopLayer');
        } else {
            $("#confirm-screen").addClass('hide');
            $("#myConfirmDiv").removeClass('bankTopLayer').addClass('bottomLayer');
        }
    },
    callConfirm: function (params) {
        var sure = $("#myConfirmDiv").find(".btn-primary");
        var cancel = $("#myConfirmDiv").find(".btn-cancle");
        sure.unbind();
        cancel.unbind();
        var sureDes = params.sureDes || '确定';
        var cancelDes = params.cancelDes || '取消';
        sure.html(sureDes);
        cancel.html(cancelDes);
        //title,content,confirmFun,cancelFun,confirmFunParam,cancelFunParam
        var confirmFun = params.confirmFun || function () {
                FN.ctrl.confirmCtrl(false);
                return true;
            };
        var cancelFun = params.cancelFun || function () {
                FN.ctrl.confirmCtrl(false);
                return false;
            };
        var confirmFunParam = params.confirmFunParam || {};
        var cancelFunParam = params.cancelFunParam || {};
        var title = params.title || '';
        var content = params.content || '';
        $("#myConfirmDiv").find(".font-xlg").html(title);
        $("#myConfirmDiv").find(".pop-box-inner").html(content);
        sure.bind('click', function () {
            confirmFun(confirmFunParam);
        });
        cancel.bind('click', function () {
            cancelFun(cancelFunParam);
        });
        FN.ctrl.confirmCtrl(true);

        // 垂直居中
        var windowHeight = document.body.scrollHeight;
        var divHeight = document.getElementById("myConfirmDiv").offsetHeight;
        var divY = (windowHeight - divHeight) / 2;
        $('#myConfirmDiv').css("top", divY);

    },
    setClock: function (seconds, domShow, domCtrl, event, params, prefix, suffix) {
        clearInterval(FN.ctrl.clock);
        prefix = prefix || '重发（';
        suffix = suffix || '秒）';
        var content = domCtrl.html();
        $(domShow).css('color', '#b3b3b3');
        FN.ctrl.clock = setInterval(function () {
            //				domCtrl.attr("disabled","disabled");
            domCtrl.unbind('click');
            domShow.html(prefix + seconds-- + suffix);
            if (seconds < 0) {
                domCtrl.html(content)
                domCtrl.html('重新发送');
                //					domCtrl.removeAttr("disabled");
                clearInterval(FN.ctrl.clock);
                $(domShow).css('color', '#3a95e6');
                domCtrl.bind('click', function () {
                    event(params)
                });
            }
        }, 1000);
    },
    getSMS: function (type, phone) {
        FN.native.get('api/user/get_hash_code', '', 'get_hashcode.get', 'json');
        FN.callbackFunc['get_hashcode.get'] = function (data) {
            if (data.error == '0') {
                FN.native.post('api/user/send_code', {
                    'type': type,
                    'phone': phone,
                    'hashCode': data.result
                }, 'get_send_code.get', 'json');
                FN.callbackFunc['get_send_code.get'] = function (data) {
                    if (data.result == '1') {
                        //FN.ctrl.smallTip('短信发送成功');
                    } else if (data.result == '0') {
                        FN.ctrl.smallTip('短信发送失败');
                    } else if (data.result == '2') {
                        FN.ctrl.smallTip('验证字符串不对');
                    } else if (data.result == '3') {
                        FN.ctrl.smallTip('发送验证码过于频繁');
                    } else if (data.result == '4') {
                        FN.ctrl.smallTip('不在校验时间内');
                    }
                };
            }
        }
    },
    getYeeSMS: function (cer_id) {
        FN.native.get('api/user/get_hash_code', '', 'get_hashcode.get', 'json');
        FN.callbackFunc['get_hashcode.get'] = function (data) {
            if (data.error == '0') {
                FN.native.post('api/my/bind_bank_card_resend_code', {
                    'cer_id': cer_id,
                    'hashCode': data.result
                }, 'get_bind_bank_card_resend_code.get', 'json');
                FN.callbackFunc['get_bind_bank_card_resend_code.get'] = function (data) {
                    if (data.result == '1') {
                        //FN.ctrl.smallTip('短信发送成功');
                    } else if (data.result == '0') {
                        FN.ctrl.smallTip('短信发送失败');
                    } else if (data.result == '2') {
                        FN.ctrl.smallTip('验证字符串不对');
                    } else if (data.result == '3') {
                        FN.ctrl.smallTip('发送验证码过于频繁');
                    } else if (data.result == '4') {
                        FN.ctrl.smallTip('不在校验时间内');
                    }
                };
            }
        }
    },
    denglongAction: function () {//中秋活动灯笼
        //首页显示中秋节灯笼活动---------------------
        var zhongqiu = FN.native.readEntry('zhongqiu', 'string', '');
        if(zhongqiu!=null&&zhongqiu!=''){
            $('.zq_tip').show();

            //跳转到活动的页面---如果在js中执行click ios会打开多次活动页面;若直接在html上onclick只会打开一次很奇怪
            /*$('.zq_tip').click(function() {
             //FN.native.loadExternal(zhongqiu);
             FN.ctrl.get('recommend').goToBannerHuoDong(zhongqiu);
             });*/
            FN.native.loadExternal(zhongqiu);
        }else{
            $('.zq_tip').hide();
            //清空存储的活动url，产品列表不再使用
            FN.native.writeEntry('zhongqiu', '', 'string', '');
        }
        //---------------------
    },
    redPacketRainAction: function () {//红包雨活动
        //首页显示红包雨活动---------------------
        // FN.native.loadExternal("https://www.zhuaqianmao.com/friendGather/index");
        var url = FN.native.readEntry('redPacketRain', 'string', '');
        if (url != null && url != '') {
            $('.redPacket_rain_tip').show();
            //跳转到活动的页面---如果在js中执行click ios会打开多次活动页面;若直接在html上onclick只会打开一次很奇怪
            /*$('.zq_tip').click(function() {
             //FN.native.loadExternal(zhongqiu);
             FN.ctrl.get('recommend').goToBannerHuoDong(zhongqiu);
             });*/
            FN.native.loadExternal(url);
        } else {
            $('.redPacket_rain_tip').hide();
            //清空存储的活动url，产品列表不再使用
            FN.native.writeEntry('redPacketRain', '', 'string', '');
        }
        //---------------------
    },
    jingqiouAction: function () {//金秋送iPhone7活动
        //显示金秋送iPhone 7活动---------------------
        var zhongqiu = FN.native.readEntry('zhongqiunew', 'string', '');
        if(zhongqiu!=null&&zhongqiu!=''){
            $('.animation_swing_box').show();
            FN.native.loadExternal(zhongqiu);
        }else{
            $('.animation_swing_box').hide();
            //清空存储的活动ur
            FN.native.writeEntry('zhongqiunew', '', 'string', '');
        }
        //---------------------
    },
    productListtipshow: function () {//产品列表页固定图片
        var zhongqiu = FN.native.readEntry('productList-tip', 'string', '');
        if(zhongqiu!=null&&zhongqiu!=''){
            //$('#productList_tip').show();
            FN.native.loadExternal(zhongqiu);
        }else{
            $('#productList_tip').hide();
            //清空存储的活动url，其他页面不再使用
            //FN.native.writeEntry('productList-tip', '', 'string', '');
        }
        //---------------------
    },
    defaultLoad: function (goBack) {
        // 安卓登出操作
        // 清空token
        if (FN.user.getIsLogin()) {
            if (!window.local_obj) {
                FN.native.writeEntry('Account', '', 'dict');
            } else {
                FN.native.writeEntry('mPhoneNum', '', 'string', 'SmallTaurus');
            }
            //调用原生,发送设备相关信息给服务端
            FN.native.sendDeviceCode();
            FN.user.saveToken('', '');
            FN.user.saveLoginStatus(false);
            FN.user.afterLoginData();
        }

        // 移除手势密码
        FN.cache.putEntry('forget_gesture_string', '0', 'string', true);

        var goBackUrl; //回退的url
        var forwardUrl; //跳转的url

        forwardUrl = 'myInvest'; // phoneNumber

        if (goBack == undefined) {
            goBackUrl = 'recommend';
        } else if (goBack == 1) {
            goBackUrl = 'recommend';
        } else if (goBack == 2) {
            goBackUrl = 'productList';
        } else if (goBack == 3) {
            goBackUrl = 'myInvest';
        } else if (goBack == 4) {
            goBackUrl = 'more';
        } else if (goBack == 5) {
            forwardUrl = 'banner';
            goBackUrl = 'recommend';
        } else if (goBack == 6) { //新增，recommend页面新人，弹出点击去注册，然后回到首页
            forwardUrl = 'recommend';
            goBackUrl = 'recommend';
        }
        FN.page.go('phoneNumber', {
            'forwardUrl': forwardUrl,
            'goBackUrl': goBackUrl,
            'type': undefined
        }, 'load');

    }
}

//页面跳转相关show()和go()
FN.page = {
    parentDom: function () {
        return $('#app')
    },
    index: {},
    current: '',
    currentEl: {},
    //页面跳转方法

    go: function (url, params, mode) {
        //alert("1"+url);
        //FN.ctrl.smallTip('1'+url);
        //清空body的背景
        $("body").removeAttr("style");
        // 取消焦点，然键盘退回
        var inputs = document.getElementsByTagName('input');
        for (var i = 0; i < inputs.length; i++) {
            inputs[i].blur();
        }
        //url:页面地址
        //params:传递的参数
        //mode:载入方式 load:新载入|reload:更新载入|'':只切换页面
        $('#footer').html('');
        FN.page.current = url;
        FN.ctrl.popupCtrl(false);
        FN.ctrl.confirmCtrl(false);
        FN.ctrl.msgTipCtrl(false);
        FN.index.closeUnusePop();	//页面跳转后关闭不需要的弹窗
        //如果能找到这个页面文件
        if (this.index[url] === true) {

            //页面第一次加载过后，后面就会执行if，走更新方法
            if (mode == undefined || mode == '') {
                //走更新方法
                FN.ctrl.get(url).update(params);

                $('#data_exception_show').addClass('hide');
                $('#net_exception_show').addClass('hide');

                //列表页面点击跳转后，在回到update，定位到前面位置
                setTimeout(function () {

                    myScroll.refresh();

                    if (url == 'productMore' || url == 'currentInvest' || url == 'investRecord') {
                        myScroll.scrollToElement(FN.page.currentEl, 0);
                    }

                    if (url == 'myassets') {
                        //滚动到上一次记录的位置
                        var curscrollposition = FN.native.readEntry('curscrollposition',
                            'string', 'scrollposition');
                        if (curscrollposition != undefined && curscrollposition != '') {

                            //myScroll.scrollTo(0, curscrollposition, 0);
                            //返回时,向上滚动的方法
                            myScroll.scrollToElement(curscrollposition, 0);
                            //清空保存的滚动位置
                            FN.native.writeEntry('curscrollposition', '', 'string', 'scrollposition');
                        }
                    }
                    if (url == 'productList') {
                        //滚动到上一次记录的位置
                        var curscrollposition = FN.native.readEntry('curscrollproductList',
                            'string', 'curscrollproductList');
                        if (curscrollposition != undefined && curscrollposition != '') {
                            //返回时,向上滚动的方法
                            myScroll.scrollToElement(curscrollposition, 0);
                            //myScroll.scrollTo(0, curscrollposition, 0);
                            //清空保存的滚动位置
                            FN.native.writeEntry('curscrollproductList', '', 'string', 'curscrollproductList');

                        }
                        var curscrollpositionNew = FN.native.readEntry('curscrollproductListNew',
                            'string', 'curscrollproductListNew');
                        if (curscrollpositionNew != undefined && curscrollpositionNew != '') {
                            myScroll.refresh();
                            //返回时,向上滚动的方法
                            myScroll.scrollTo(0, curscrollpositionNew, 0);
                            //清空保存的滚动位置
                            FN.native.writeEntry('curscrollproductListNew', '', 'string', 'curscrollproductListNew');
                        }
                    }
                }, 500);
            } else if (mode == 'load') {
                if (url != 'secure')
                    FN.native.openWaitDialog();

                //先清理掉前面页面内容
                $('#' + url + '_show').html('&nbsp;');

                //初始化加载当前页面内容,调用init方法
                FN.ctrl.get(url).init(params);

                setTimeout(function () {
                    //myScroll.refresh();//加载图片重新计算高度
                    myScroll.scrollTo(0, 0, 0);

                }, 800);
            } else if (mode == 'reload') {
                //TODO 添加加载页面动画
                if (FN.page.current != 'more') {
                    FN.ctrl.showScroller(true, false);
                }

                //重新加载当前页面内容，update回来执行。。
                FN.ctrl.get(url).init(params);

                //刷新页面
                setTimeout(function () {
                    //recommend滚动到上一次记录的位置
                    var curscrollposition = FN.native.readEntry('curscrollrecommend',
                        'string', 'scrollrecommend');
                    if (curscrollposition != undefined && curscrollposition != '') {
                        //返回时,向上滚动的方法
                        myScroll.scrollToElement(curscrollposition, 0);
                        //清空保存的滚动位置
                        FN.native.writeEntry('curscrollrecommend', '', 'string', 'scrollrecommend');
                    }
                    else {
                        //滚动到顶部
                        myScroll.scrollTo(0, 0, 0);
                    }
                }, 500);
            }
            //$('.ctrl').fadeOut("slow",'linear');
            //$('#'+url).fadeIn("slow",'linear');
            if (!window.local_obj) { //ios还是保持原样
                $('.ctrl').hide();
                //FN.ctrl.viewport(url);
                $('#' + url).show();
            } else {
                //alert('2'+url);
                //FN.ctrl.smallTip('2'+url);
                $('.ctrl').hide();
                //FN.ctrl.viewport(url);
                $('#' + url).show();
            }
            //转到页面
            //FN.page.go('secureCar',params.data,'load');
            //$('#'+goBackUrl+'_show').html('&nbsp;');
            //$.mobile.changePage('#'+url, {transition:"slide",reverse:false}, true, true);
            //如果是首页和产品列表页面显示 ，摇摆的灯笼中秋节
            if (url != 'recommend' && url != 'productList') {
                $('.zq_tip').hide();
            }
            if (url != 'productList') {
                $('#productList_tip').hide();
            }
            if (url != 'recommend'&& url != 'productList' && url != 'myInvest'){
                $('.animation_swing_box').hide();
            }
            if (url != 'myInvest' && url != 'productList') {
                $('.redPacket_rain_tip').hide();
            }
            //--------------------------------------

            //页面update的时候也传递进入页面的name给原生比对版本是否有更新。。。
            FN.native.setPageName(url, 'page.go');

        } else {
            //页面初始化进来，会执行，已经加载过，直接执行if中的update
            //原生里面,顶部返回按钮，执行fn.page.go('')
            this.index[url] = params;
            FN.callbackFunc['page.go'] = function (p) {
                if (p.html == undefined) {
                    return;
                }
                //$('.ctrl').hide();
                if (url != 'secure')
                    FN.native.openWaitDialog();

                params = FN.page.index[p.url];
                FN.page.index[p.url] = true;
                var page = document.createElement("div");
                page.id = p.url;
                page.className = 'ctrl';
                page.innerHTML = '<script id="' + p.url + '_tpl" type="text/html">' + p.html + '</script><div id="' + p.url + '_show">&nbsp;</div>';
                FN.page.parentDom().append(page);

                FN.ctrl.run(p.url);

                //原生顶部返回按钮，会直接执行fn.page.go;会执行模块的init方法
                FN.ctrl.get(p.url).init(params);

                if (!window.local_obj) { //ios还是保持原样
                    $('.ctrl').hide();
                    //FN.ctrl.viewport(url);
                    $('#' + p.url).show();

                } else {
                    // alert('3'+url);
                    //FN.ctrl.smallTip('3'+url);
                    //FN.ctrl.smallTip('3'+p.url);
                    $('.ctrl').hide();
                    //FN.ctrl.viewport(url);
                    $('#' + p.url).show();
                }
                //$('.ctrl').fadeOut("slow",'linear');
                //$('#'+p.url).fadeIn("slow",'linear');
                //$.mobile.changePage('#'+url, {transition:"slide",reverse:false}, true, true);

                //如果是首页和产品列表页面显示 ，摇摆的灯笼中秋节
                if (p.url != 'recommend' && p.url != 'productList') {
                    $('.zq_tip').hide();
                }
                if (p.url != 'productList') {
                    $('#productList_tip').hide();
                }
                if(p.url!= 'recommend' && p.url != 'productList' && p.url != 'myInvest'){
                    $('.animation_swing_box').hide();
                }
                if (url != 'myInvest' && url != 'productList') {
                    $('.redPacket_rain_tip').hide();
                }
                //--------------------------------------


            }

            //调用原生,JSUtil中的jump方法；然后回调回来
            FN.native.updPage(url, 'page.go');
        }
        if (url != 'productMore' && url != 'myassets') {
            myScroll.scrollTo(0, 0, 0);
        }

        //setTimeout(function(){myScroll.refresh();},800);
    },
    go_ex: function (el, url, params, mode) {
        FN.page.currentEl = el;
        FN.page.go(url, params, mode);
    }
}

//处理.set()方法回调
FN.callbackFunc = {
    do: function (key, params) {

        //如果有error,就统一关闭
        if (params.error != undefined && params.error != '1') {
            FN.native.closeWaitDialog();
            //根据当前页面是否已经加载出了html页面，然后提示dialog，还是html内容
            var isdialog = !($('#' + FN.page.current + '_show').html() == '' || $('#' + FN.page.current + '_show').html() == '&nbsp;');
            //alert(isdialog);
            if (FN.ctrl.exception(params, isdialog)) {

                return;
            }

        }

        console.log(params);
        FN.callbackFunc[key] == null ? '' : this[key](params);

    }
}

//原生交互和具体的业务模块逻辑
FN.native = {
    log: function (log) {
        if (window.local_obj) {
            window.local_obj.log(log);
        }
    },
    showPic: function (url) {
        if (FN.debug) {
            window.open(url);
        } else {
            if (!window.local_obj) {
                ios_showPic(url);
            } else {
                window.local_obj.showPic(url);
            }
        }
    },
    getLolVerson: function () {

        if (!window.local_obj) {
            return ios_verson();

        } else {
            return window.local_obj.localversion();
        }
    },
    getOffLineMsg:function(){
        if (!window.local_obj) {
            return ios_unMsg();
        } else {
            return window.local_obj.getOffLineMsg();
        }
    },
    openWaitDialog: function () {

        if (FN.debug) {

        } else {
            if (!window.local_obj) {
                ios_dialog(1);
            } else {
                window.local_obj.controlCoverLayer(false);
            }
        }
    },
    closeWaitDialog: function () {
        if (FN.debug) {

        } else {
            if (!window.local_obj) {
                ios_dialog(0);
            } else {
                window.local_obj.controlCoverLayer(true);
            }
        }
    },
    doNativeTime: null,
    loadExternal: function (url, type) {
        if (FN.debug) {
            if (!url.startWith('http://') && !url.startWith('https://'))
                url = 'http://localhost:8080/' + url;
            window.open(url);
        } else {
            if (!window.local_obj) {

                // 如果是不完整的路径，拼成完整的
                //				if(url.indexOf('http') == -1){
                //					var domainStr = FN.native.readEntry('domain_string','string','H5_BUSINESS_CACHE');
                //					var domainObj = JSON.parse(domainStr);
                //					if(domainObj && domainObj.result && domainObj.result.domain)
                //						url = domainObj.result.domain+'/'+url;
                //				}
                ios_loadExternal(url, type);
            } else {
                window.local_obj.loadExternal(url);
            }
        }
    },
    ios_setTabbarShow: function (isShow) {
        if (FN.debug) {
            if (!url.startWith('http://'))
                url = 'http://localhost:8080/' + url;
            window.open(url);
        } else {
            ios_setTabbarShow(isShow);
        }
    },
    callNativeCtrl: function (methodName, json) {

        if (FN.debug) {

        } else {
            if (!window.local_obj) {
                window.location = 'ios_callnativectrl[@@]' + methodName + '[@@]' + JSON.stringify(json);
            } else {
                window.local_obj.callNativeCtrl(methodName, JSON.stringify(json));
            }
        }
    },
    updPage: function (url, backFunc) {
        if (FN.debug) {
            $.get('./tpl/' + url + '/' + url + '.html', {}, function (data) {
                FN.callbackFunc.do('page.go', {
                    url: url,
                    html: data
                });
            }, 'text');
        } else {
            if (!window.local_obj) {
                ios_jumppage(url, backFunc);
            } else {
                window.local_obj.jumpPage(url, backFunc);
            }
        }
    },
    request: function (params) {
        var url = params.url,
            data = params.data || null,
            source = params.source, //回调
            type = params.type, //string/json
            method = params.method; //post/get

        if (!window.top.local_obj) {
            ios_request(url, method, JSON.stringify(data), type, source);
        } else {
            if (method == 'post') {
                var domainStr = FN.native.readEntry('domain_string', 'string', 'H5_BUSINESS_CACHE');
                var domainObj = JSON.parse(domainStr);
                if (domainObj && domainObj.result && domainObj.result.domain)
                    url = domainObj.result.domain + '/' + url;
            }
            window.top.local_obj.request(url, method, JSON.stringify(data), type, source); //
        }
    },
    iosDoNative: function (str) {
        var now = new Date().getTime();

        if (FN.native.doNativeTime != null && (now - FN.native.doNativeTime) < 10) {
            setTimeout(function () {
                FN.native.iosDoNative(str)
            }, 10);
        } else {
            window.location = str;
            FN.native.doNativeTime = now;
        }
    },
    post: function (url, data, source, type) {
        if (FN.debug) {
            $.post(url, data, function (data) { //FN.debugUrl+
                FN.callbackFunc.do(source, data);
            }, type);
        } else {
            FN.native.request({
                'url': url,
                'data': data,
                'source': source,
                'type': type == undefined ? 'json' : type,
                'method': 'post'
            });
        }
    },
    get: function (url, data, source, type) {
        if (FN.debug) {
            $.get(url, data, function (data) { //FN.debugUrl+
                FN.callbackFunc.do(source, data);
            }, type);
        } else {
            FN.native.request({
                'url': url,
                'data': data,
                'source': source,
                'type': type == undefined ? 'json' : type,
                'method': 'get'
            });
        }
    },
    setHead: function (params) {
        var backUrl = params.url || ''; //点击返回按钮执行 FN.callbackFunc.do('page.go',url)
        var title = params.title || ''; //显示的标题
        var icon = params.icon || {}; //{url:链接页面,img:显示的图标,target:new(新的webview中打开链接)|self}

        if (FN.debug) {

        } else {
            if (!window.local_obj) {
                ios_sethead(backUrl, title, JSON.stringify(icon));
            } else {
                window.local_obj.setHead(backUrl, title, JSON.stringify(icon));
            }
        }
    },
    setPageName: function (url, backFunc) { //新增，页面init初始化和update都执行
        if (FN.debug) {

        } else {
            if (!window.local_obj) {
                getCurPageName(url, backFunc);
            } else {
                window.local_obj.getCurPageName(url, backFunc);
            }
        }
    },
    setNavi: function (params) {
        var show = params.show;
        var tab = params.tab || '';
        //show  1显示菜单栏|0不显示菜单栏
        //tab   recommend重点推荐|productList理财产品|myInvest我的投资|more更多

        if (FN.debug) {

        } else {
            if (!window.local_obj) {
                ios_setnavi(show, tab);
            } else {
                window.local_obj.setNavi(show, tab);
            }
        }
    },
    getConf: function () {

    },
    more2NativeView: function (type, json, callback) {
        if (!window.local_obj) {
            ios_more2NativeView(type, json, callback);
        } else {
            window.local_obj.more2NativeView(type, json, callback);
        }
    },
    writeEntry: function (key, value, type, cacheName) {
        if (FN.debug) {

        } else {
            if (!window.local_obj) {
                ios_setValueToNative(key, value, type);
            } else {
                window.local_obj.setValue2Native(key, value, type, cacheName);
            }
        }
    },
    readEntry: function (key, type, cacheName) {
        if (FN.debug) {

        } else {
            if (!window.local_obj) {
                if (key == 'mPhoneNum') {
                    var value = FN.native.readEntry('Account', 'dict');
                    if (value) {
                        return value.username;
                    }
                }
                return ios_getValueFromNative(key, type);
            } else {
                return window.local_obj.getValueFromNative(key, type, cacheName);
            }
        }
    },
    sendDeviceCode: function () {
        if (FN.debug) {

        } else {
            //androidinfo:1,iosinfo:1  给服务端传递，设备唯一识别码
            var cid = FN.native.readEntry('clientid', 'string', 'PUSHINFO');
            FN.native.get('api/user/send_device_code', {device_code:cid,androidinfo:1,iosinfo:1}, '', 'json');
        }
    }
}

FN.util = {
    //保留小数点后两位，向下取舍
    changeTwoDecimalF: function (floatvar) {
        var f_x = parseFloat(floatvar);
        if (isNaN(f_x)) {
            return false;
        }
        var f_x = Math.floor(Math.round(f_x * 1000) / 10) / 100;
        //var f_x = Math.floor(f_x*100)/100;
        var s_x = f_x.toString();
        var pos_decimal = s_x.indexOf('.');
        if (pos_decimal < 0) {
            pos_decimal = s_x.length;
            s_x += '.';
        }
        while (s_x.length <= pos_decimal + 2) {
            s_x += '0';
        }
        return s_x;
    },
    changeOneDecimalF: function (floatvar) { //保留小数点后1位，向下取舍
        var f_x = parseFloat(floatvar);
        if (isNaN(f_x)) {
            return false;
        }
        var f_x = Math.floor(Math.round(f_x * 1000) / 10) / 100;
        //var f_x = Math.floor(f_x*100)/100;
        var s_x = f_x.toString();
        var pos_decimal = s_x.indexOf('.');
        if (pos_decimal < 0) {
            pos_decimal = s_x.length;
            s_x += '.';
        }
        while (s_x.length <= pos_decimal + 1) {
            s_x += '0';
        }
        return s_x;
    },
    salesProgress: function (progress) {
        //计算销售当前进度
        var f_x = parseFloat(progress);
        if (isNaN(f_x)) {
            return false;
        }
        if (f_x < 0.01 && f_x > 0) f_x = 0.01;
        if (f_x > 0.99 && f_x < 1) f_x = 0.99;

        var resultprog = Math.round(f_x * 100);
        if (resultprog > 100)
            resultprog = 100;

        return resultprog;
    },
    formatTimestampshiqu: function (timestamp, format) {
        //有时区

        /*
         * eg:format="yyyy-MM-dd hh:mm:ss";
         */
        var date = new Date(parseInt(timestamp));
        //获取当前时区对0时区的偏移量
        var localOffset = date.getTimezoneOffset() * 60000;
        //获取0时区时间
        var utc = date.getTime() + localOffset;
        //转换成北京时区时间
        var bjTime = utc + 3600000 * 8;

        date = new Date(bjTime);
        var o = {
            "M+": date.getMonth() + 1, // month
            "d+": date.getDate(), // day
            "h+": date.getHours(), // hour
            "m+": date.getMinutes(), // minute
            "s+": date.getSeconds(), // second
            "q+": Math.floor((date.getMonth() + 3) / 3), // quarter
            "S": date.getMilliseconds()
            // millisecond
        }
        if (/(y+)/.test(format)) {
            format = format.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));
        }
        for (var k in o) {
            if (new RegExp("(" + k + ")").test(format)) {
                format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
            }
        }
        return format;
    },
    formatTimestamp: function (timestamp, format) {
        /*
         * eg:format="yyyy-MM-dd hh:mm:ss";
         */
        var date = new Date(parseInt(timestamp));
        var o = {
            "M+": date.getMonth() + 1, // month
            "d+": date.getDate(), // day
            "h+": date.getHours(), // hour
            "m+": date.getMinutes(), // minute
            "s+": date.getSeconds(), // second
            "q+": Math.floor((date.getMonth() + 3) / 3), // quarter
            "S": date.getMilliseconds()
            // millisecond
        }
        if (/(y+)/.test(format)) {
            format = format.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));
        }
        for (var k in o) {
            if (new RegExp("(" + k + ")").test(format)) {
                format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
            }
        }
        return format;
    },
    formatDaytamp: function (curdate, selldate, format) {
        var curstr = new Date(parseInt(curdate));
        var curyear = curstr.getFullYear();
        var curmonth = curstr.getMonth() + 1;
        var curday = curstr.getDate();
        //转成时间戳
        //var starttime = new Date(curyear, curmonth, curday);
        // starttimes=starttime.getTime();

        //销售时间时分秒
        var sellstr = new Date(parseInt(selldate));

        var str = curyear + '/' + curmonth + '/' + curday + ' 00:00:00';
        //str = str.replace(/-/g,"/");
        var starttime = new Date(str);
        starttimes = starttime.getTime();

        var days = Number(Number((selldate - starttimes) / 1000) / 3600) / 24;

        if (0 < days && days < 1) {
            return '今天 ' + FN.util.checkTime(sellstr.getHours()) + ':' + FN.util.checkTime(sellstr.getMinutes());
        } else if (1 < days && days < 2) {
            return '明天 ' + FN.util.checkTime(sellstr.getHours()) + ':' + FN.util.checkTime(sellstr.getMinutes());
        } else if (2 < days && days < 3) {
            return '后天 ' + FN.util.checkTime(sellstr.getHours()) + ':' + FN.util.checkTime(sellstr.getMinutes());
        }

        return sellstr.getFullYear() + '-' + FN.util.checkTime((sellstr.getMonth() + 1)) + '-' + FN.util.checkTime(sellstr.getDate()) + ' ' + FN.util.checkTime(sellstr.getHours()) + ':' + FN.util.checkTime(sellstr.getMinutes());
    },
    phoneRule: function (phone) {
        var rule = /^1\d{10}$/;
        return rule.test(phone);
    },
    checkTime: function (i) {
        if (i < 10) {
            i = "0" + i
        }
        return i
    },
    MD5: function (str) {
        return hex_md5(str);
    },
    checkPassword: function (password) {
        // 判断全角字符
        //		if (password.length>0)
        //		{
        //			for (var i = password.length-1; i >= 0; i--)
        //			{
        //				unicode=password.charCodeAt(i);
        //				if (unicode > 65248 || unicode == 12288)
        //				{
        //					FN.ctrl.smallTip('密码格式错误');
        //					return false;
        //				}
        //			}
        //		}

        if (password.length < 6) {
            FN.ctrl.smallTip('密码长度必须大于6位');
            return false;
        }

        return true;
    },
    /**
     * 重新设置 document.body 的高度
     * 因为 body 的默认高度为 100%，在
     * Android 下会造成一些问题，比如：
     * 键盘弹起使得一些元素定位出错
     */
    resetBodyHeight: function () {
        var windowHeight = document.documentElement.clientHeight;
        document.body.style.height = windowHeight + 'px';
        $('#scroll').height(windowHeight);
    },
    closesongquan: function () { //关闭index.html中弹窗 首页满20000w送1%加息券弹窗
        $('#songquan_pop').hide();
    },
    closejxpop: function () { //关闭index.html中弹窗 加息券规则
        $('#div_pop_jx').hide();
    },
    closefbpop: function () { //关闭index.html中弹窗  四月活动
        $('#div_feedback').hide();
    },
    closeuppop: function () { //关闭index.html中弹窗  提示升级
        //$('#div_update_pop').hide();
    },

    uploadnewapp: function () { //关闭index.html中弹窗  提示升级
        //window.location.href = "http://s.xiaojinniu.com/dd.myapp.com/zhuaqianmao.apk";//未设置setDownloadListener
        //window.location.href="http://a.app.qq.com/o/simple.jsp?pkgname=com.xiaojinniu.smalltaurus";//shouldOverrideUrlLoading已设置不能返回
        //window.location.href = "market://details?id=com.xiaojinniu.smalltaurus";//未实现market协议
        //alert("uploadnewapp");
        //copyToClipBoard("baidu.com");
    },
    closecommonpop: function () { //关闭index.html中弹窗  公用弹窗
        $('#div_common_pop').hide();
    },
    gotohongbao: function () {
        $('#div_common_pop').hide();
        FN.page.go('myhongbao', '', 'load');
    },
    closehbpop: function () { //关闭index.html中弹窗 红包规则
        $('#div_pop_hb').hide();
    },
    closehongbao: function () { //关闭index.html中弹窗 红包奖励
        $('#hongbao_pop').hide();
    },
    closeliuliang: function () { //关闭index.html中弹窗 流量奖励
        $('#liuliang_pop').hide();
    },
    closemyreward: function () { //关闭index.html中弹窗 修改/添加地址 我的奖品
        $('#div_myreward_pop').hide();
    },
    closeExperienceGet: function () {//关闭index.html中弹窗 领取收益
        $('#div_experienceGet_pop').hide();
    },
    closeExperienceSuccess: function () {//关闭index.html中弹窗 领取体验金成功
        $('#div_experienceSuccess_pop').hide();
    },
    closeExperienceError2: function () {//关闭index.html中弹窗 体验金失效(主动点击的)
        $('#div_experienceError_pop2').hide();
    },
    closeExperienceRuler: function () {//关闭index.html中弹窗 体验金规则
        $('#div_experienceRule_pop').hide();
    },
    scrolladd: function () { //单独适配顶部的scroll样式

        $('html').addClass('viewport');
    },
    scrollremove: function () { //移除单独适配顶部的scroll样式
        $('html').removeClass('viewport');
    },
    banneradd: function () { //单独适配顶部的banner样式

        //通过useragent来区分android还是ios 动态的适配4s和5s首页的高度
        sys = navigator.userAgent.match(/(iPhone|iPod|iPad);?/i) ? 'ios' : 'android';

        if (sys == 'ios') {
            //通过高度来判断是否是iPhone 4还是iPhone 5
            isPhone4inches = (window.screen.height == 480);
            isPhone5inches = (window.screen.height == 568);

            //动态给recomend.html中div添加css
            if (isPhone4inches) {
                $('.topbanner').addClass('top4');

            } else if (isPhone5inches) {
                $('.topbanner').addClass('top5');

            } else {
                $('.topbanner').addClass('top6p');

            }

        }
    },
    bannerremove: function () { //移除单独适配顶部的banner样式
        //通过useragent来区分android还是ios 动态的适配4s和5s首页的高度
        sys = navigator.userAgent.match(/(iPhone|iPod|iPad);?/i) ? 'ios' : 'android';

        if (sys == 'ios') {
            //通过高度来判断是否是iPhone 4还是iPhone 5
            isPhone4inches = (window.screen.height == 480);
            isPhone5inches = (window.screen.height == 568);

            //动态给recomend.html中div添加css
            if (isPhone4inches) {
                $('.topbanner').removeClass('top4');
            } else if (isPhone5inches) {
                $('.topbanner').removeClass('top5');
            } else {
                $('.topbanner').removeClass('top6p');
            }
        }
    },
    closeliwu: function () { //关闭index.html中弹窗 礼物奖励
        $('#liwu_pop').hide();
    },
    checkInputNumber: function (_el) {
        if (_el.value.length == 1) {
            _el.value = _el.value.replace(/[^1-9]/g, '')
        } else {
            //清空所有非数字的,/g表示全文查找
            _el.value = _el.value.replace(/\D/g, '')
        }
    },
    checkIsNumber: function (value) {
        if (value.length == 1) {
            value = value.replace(/[^1-9]/g, '')
        } else {
            value = value.replace(/\D/g, '')
        }
    },
    checkAndChange2Number: function (_el) {
        if (_el.value.length == 1) {
            _el.value = _el.value.replace(/[^1-9]/g, '')
        } else {
            //清空所有非数字的,/g表示全文查找
            _el.value = _el.value.replace(/\D/g, '')
        }

        var money = Number(_el.value);
        //输入购买金额判断onkeyup起来时候，重新计算
        //计算使用加息券收益（因为红包和加息券，不能同时使用,需要在方法里面判断是否选中才执行)
        FN.ctrl.get('payInput').jiaxiMoneynew(money);

        //计算选择红包抵扣金额（因为红包和加息券，不能同时使用,需要在方法里面判断是否选中才执行)
        FN.ctrl.get('payInput').hongbaoMoneynew(money);

    },
    checkIsIdentifyCode: function (value) {

        if (value.length <= 0) return false;
        value = value.replace(/^(\\d{14}|\\d{17})(\\d|[xX])$/g, '');
    },
    checkInputField: function (_el) {
        var value = $(_el).val();
        if (value.length > 0) {
            if (!$(_el).next().hasClass('quickdelete')) {
                $(_el).after('<a href="javascript:;" class="quickdelete" onclick="FN.util.clearInputField(this);"></a>')
            }
        } else {
            if ($(_el).next().hasClass('quickdelete')) {
                $(_el).next().remove();
            }
        }
    },
    reloadView: function (_el) {//刷新页面,重新计算高度
        myScroll.refresh();
    },
    checkPwdData: function (_el) { //密码只能输入数字和字母

        var value = $(_el).val();

        //$(_el).val(value.replace(/[^\w\.\/]/ig,''));//   ^[a-zA-Z0-9]$
        //$(_el).val(value.replace(/[^\d|chun]/g,''));
        $(_el).val(value.replace(/[^a-zA-Z0-9]/g, ''));

    },
    checkInpytData: function (_el) { //只能输入整数，同时修改 "本月应付"金额--定存购买

        var value = $(_el).val();

        if (value.length == 1) {
            $(_el).val(value.replace(/[^1-9]/g, ''));
        } else {
            $(_el).val(value.replace(/\D/g, ''));
        }

        //同时修改，应付金额
        $('#span_moneypremonth').text($(_el).val());

    },
    checkInpytDay: function (_el, monthlength) { //输入1-28之间的日期,同时修改 "到期时间" 显示--定存购买
        //monthlength是理财周期月

        var value = $(_el).val();

        if (value.length == 1) {
            $(_el).val(value.replace(/[^1-9]/g, ''));
        } else {
            //限制在1-28之间
            if (parseInt(value) > 28 || parseInt(value) < 1) {
                $(_el).val('');
                FN.ctrl.smallTip('请输入1-28之间整数');
            } else
                $(_el).val(value.replace(/\D/g, ''));
        }

        //同时修改，到期时间，年月日--显示本月的
        var mydate = new Date();

        //判断如果超过12月，就要年份+1;月相剪
        var tomonth = mydate.getMonth() + 1 + parseInt(monthlength);
        var toyear = mydate.getFullYear();
        if (tomonth > 12) {
            tomonth = tomonth - 12;
            toyear = toyear + 1;

        }

        if ($(_el).val() != '') {
            var str = "" + toyear + "-";
            str += tomonth + "-";
            str += $(_el).val() + ""; // mydate.getDate()

            $('#span_endtime').text(str);
        }

    },
    clearInputField: function (_el) { //清空输入框
        var el = $(_el);
        el.prev().val('');
        el.remove();

        //同时隐藏页面上的，加息券提示div
        var div_tips = $('#p_jxdes');
        if (div_tips != undefined) {
            $('#p_jxdes').hide();
            $('#p_jxdes').text('');
        }

        //同时隐藏页面上的,红包提示div
        FN.ctrl.get('payInput').hongbaoMoneynew(0);
    },
    clearPhoneField: function (_el) {
        FN.util.clearInputField(_el);
        $('.showNo').addClass('hide');
    },
    checkPhoneField: function (_el) {
        var phone = $(_el).val();
        if (phone.length > 0) {
            if (!$(_el).next().hasClass('quickdelete')) {
                $(_el).after('<a href="javascript:;" class="quickdelete" onclick="FN.util.clearPhoneField(this);"></a>')
            }
            $('.showNo').removeClass('hide');
            if (phone.length <= 3) {
                $('.showNo').html(phone);
            } else if (phone.length <= 7) {
                $('.showNo').html(phone.substring(0, 3) + ' ' + phone.substring(3));
            } else if (phone.length <= 11)
                $('.showNo').html(phone.substring(0, 3) + ' ' + phone.substring(3, 7) + ' ' + phone.substring(7));
        } else {
            if ($(_el).next().hasClass('quickdelete')) {
                $(_el).next().remove();
                $('.showNo').addClass('hide');
            }
        }
        if (phone.length > 11) {
            $(_el).val(phone.substring(0, 11));
        }
    },
    checkIdentityField: function (_el) {
        var value = $(_el).val();
        FN.util.checkInputField(_el);
        if (value.length > 18) {
            $(_el).val(value.substring(0, 18));
        }
    },
    checkBankCardField: function (_el) {
        var value = $(_el).val();
        FN.util.checkInputField(_el);
        if (value.length > 19) {
            $(_el).val(value.substring(0, 19));
        }
    },
    checkSMSField: function (_el) {

        var value = $(_el).val();

        $(_el).val(value.replace(/[^a-zA-Z0-9]/g, ''));

        if (value.length > 6) {
            $(_el).val(value.substring(0, 6));

        }
    },
    checkSMSFieldForPay: function (_el) {

        var value = $(_el).val();
        value=value.replace(/[^0-9]/g, '');//对于非数字字母的，全部替换成空
        //value=value.replace(/[^a-zA-Z0-9]/, '');
        $(_el).val(value);

    },
    checkLoginPassword: function (value) {
        var rule = /^[a-zA-Z0-9]{6,20}$/;
        return rule.test(value); //test
    },
    matchNumber: function (val) {
        var rule = /^[0-9]*$/g;
        return rule.test(val);
    },
    setGlobelBGColor: function () {
        // 设置背景色
        $("body").css('background-color', '#eee');
    },
    setSecurePhone: function (phoneNum) {
        if (!phoneNum.length) return '号码为空';
        return phoneNum.substring(0, 3) + '****' + phoneNum.substring(7);
    },
    'adjustView': function (isUp, name, offset) {
        if (isUp) {
            $('#' + name + '_show').css('marginTop', -offset + 'px');
        } else {
            $('#' + name + '_show').css('marginTop', 0 + 'px');
        }
    },
	addDate: function (days) {
        var date = new Date();
		date.setDate(date.getDate() + days);
		var month = date.getMonth() + 1;
		var day = date.getDate();
		if (month < 10) {
			month = "0" + month;
		}
		if (day < 10) {
			day = "0" + day;
		}
		var val = date.getFullYear() + "" + month + "" + day;
		return val;
    }
}

FN.cache = {
    selectRed: 0, //红包类型 13表示1：1000红包， 14其他红包
    selectID: 0, //红包
    selectRedValue: 0,
    selectRedRate: 0,
    selectReward: 0, //加息卷ID
    selectRewardShare: 0,

    preference: {
        putEntry: function (key, value, type) {
            FN.native.writeEntry(key, value, type, 'H5_BUSINESS_CACHE');
        },
        getEntry: function (key, type) {
            return FN.native.readEntry(key, type, 'H5_BUSINESS_CACHE');
        }
    },
    memory: {
        map: {},
        putEntry: function (key, value) {
            FN.cache.memory.map[key] = value;
        },
        getEntry: function (key) {
            return FN.cache.memory.map[key];
        }
    },
    putEntry: function (key, value, type, isNative) {
        isNative = isNative || false;
        type = type || 'string';
        if (isNative) {
            FN.cache.preference.putEntry(key, value, type);
        } else {
            FN.cache.memory.putEntry(key, value);
        }
    },
    getEntry: function (key, type, isNative) {
        isNative = isNative || false;
        type = type || 'string';
        if (isNative) {
            return FN.cache.preference.getEntry(key, type);
        } else {
            return FN.cache.memory.getEntry(key);
        }
    },
}

FN.user = {
    saveLoginStatus: function (isLogin) {
        FN.native.writeEntry('', '', 'clearAll', 'login');
        FN.native.writeEntry('islogin', isLogin + '', 'boolean', 'login');
        FN.native.writeEntry('LoginStatus', isLogin + '', 'string', 'login');
    },
    saveToken: function (key, hash_code) {
        if (!window.local_obj) {
            var value = FN.native.readEntry('Account', 'dict');
            if (value) {
                value.Token = key;
                value.HashCode = hash_code;
                if (!value.uid) {
                    value.uid = '';
                }
                if (!value.username) {
                    value.username = '';
                }
                if (!value.GuestCache) {
                    value.GuestCache = '';
                }
            } else {
                var value = {};
                value.Token = key;
                value.HashCode = hash_code;
                value.username = '';
                value.GuestCache = '';
                value.uid = '';
            }
            FN.native.writeEntry('Account', JSON.stringify(value), 'dict');
            FN.native.writeEntry('', '', 'reloadAccount');
        } else {
            FN.native.writeEntry('key', key, 'string', 'token');
            FN.native.writeEntry('hashCode', hash_code, 'string', 'token');
        }
    },
    saveUserInfo: function (phone, name, idcard, payPwd, cert) {
        FN.native.writeEntry('userPhone', phone, 'string', 'userInfo');
        FN.native.writeEntry('userName', name, 'string', 'userInfo');
        FN.native.writeEntry('userIdCard', idcard, 'string', 'userInfo');
        FN.native.writeEntry('isSetPayPassword', payPwd, 'string', 'userInfo');
        FN.native.writeEntry('certification', cert, 'string', 'userInfo');
        if (!window.local_obj) {
            // iOS下，保存userName
            var value = FN.native.readEntry('Account', 'dict');
            if (value) {
                value.username = phone;
            } else {
                var value = {};
                value.username = phone;
            }
            FN.native.writeEntry('Account', JSON.stringify(value), 'dict');
            FN.native.writeEntry('', '', 'reloadAccount');
        }
    },
    afterLoginData: function () {
        FN.native.get('api/my/get_user_info', {}, 'get_user_info.get', 'json');
        FN.callbackFunc['get_user_info.get'] = function (data) {
            FN.user.saveUserInfoData(data);
        }
    },
    saveUserInfoData: function (data) {
        if (data.error == '0') {
            if (data.result.certification == '1') {
                FN.native.writeEntry('mBankName', data.result.bankName, 'string', 'BANKINFO');
                FN.native.writeEntry('mBankName', data.result.bankCardNo, 'string', 'BANKINFO');
            } else {
                FN.native.writeEntry('', '', 'clearAll', 'BANKINFO');
            }

            FN.user.saveUserInfo(data.result.phone, data.result.userName, 'null' == data.result.idCard ? '' : data.result.idCard.substring(0, 4) + "**********" + data.result.idCard.substring(14), data.result.isSetPayPassword, data.result.certification);
        }
    },
    getIsLogin: function () {
        if (!window.local_obj) {
            var value = FN.native.readEntry('Account', 'dict');
            if (FN.debug == 1) return true;
            if (!value) return false;

            if (value.Token) {
                return true;
            } else {
                return false;
            }
        } else {
            return FN.native.readEntry('islogin', 'boolean', 'login') == 'true';
        }
    },
    getUserPhone: function () {
        if (!window.local_obj) {
            var value = FN.native.readEntry('Account', 'dict');
            return value.username;
        } else {
            return FN.native.readEntry('mPhoneNum', 'string', 'SmallTaurus');
        }
    }
}
/**
 * Set app's div height.
 */
FN.native.adjustAppHeight = function () {
    //	$('#app').removeAttr("style");
    //	var appHeight = document.getElementById("app").offsetHeight;
    //	var windowHeight = window.screen.height - 64;
    //	if(appHeight <= windowHeight){
    //		$('#app').css('height',windowHeight);
    //	}else{
    //	}
    //    myScroll.refresh();
};

var myScroll,
    pullDownEl, pullDownOffset,
    pullUpEl, pullUpOffset, curscrollY, pullUpElNew,
    generatedCount = 0;
$(document).ready(function () {
    pullDownEl = document.getElementById('pullDown');
    pullUpEl = document.getElementById('pullUp');
    pullDownOffset = pullDownEl.offsetHeight;
    pullUpOffset = pullUpEl.offsetHeight;

    pullUpElNew = document.getElementById('scroll-upmore');
    var id = 'scroll';
    var yLen = 60;//控制上拉分屏的力度(间距)

    myScroll = new iScroll(id, {
        useTransition: false,
        hScrollbar: false,
        vScrollbar: false,
        topOffset: pullDownOffset,
        onRefresh: function () {
            if (pullDownEl.className.match('loading')) {

                pullDownEl.className = '';
                pullDownEl.querySelector('.pullDownLabel').innerHTML = '下拉刷新...';
            } else if (pullUpEl.className.match('loading') && FN.page.current != 'productList') {
                pullUpEl.className = '';
                $(pullUpEl).hide();
                pullUpEl.querySelector('.pullUpLabel').innerHTML = '上拉加载更多...';

            } else if (pullUpElNew.className.match('loading') && FN.page.current == 'productList') {
                pullUpElNew.className = '';
                $(pullUpElNew).hide();
                pullUpElNew.querySelector('.line-title span').innerHTML = '向上滑动查看更多兑付期';

            }
        },
        onScrollMove: function () {
            if (this.y < curscrollY * 9 && this.y > curscrollY * 12) {
                this.y = this.y / 10;
            } else if (this.y < curscrollY * 99 && this.y > curscrollY * 102) {
                this.y = this.y / 100;
            }
            //取计算后的值(在产品列表返回地位后,滑动后的this.y值确保正确)
            var y4 = this.y;
            this.y = eval(y4);
            var up = FN.ctrl.get(FN.page.current)['scrollUp'] == undefined ? false : true;
            var down = FN.ctrl.get(FN.page.current)['scrollDown'] == undefined ? false : true;
            console.log("this.y:" + this.y + "||this.maxScrollY:" + this.maxScrollY);
            if (down && this.y > 0) {
                $(pullDownEl).show();
                if (this.y >= yLen && !pullDownEl.className.match('flip')) {
                    console.log(1);
                    pullDownEl.className = 'flip';
                    pullDownEl.querySelector('.pullDownLabel').innerHTML = '松手开始更新...';
                    this.minScrollY = 0;
                } else if (this.y < yLen && pullDownEl.className.match('flip')) {
                    console.log(2);
                    pullDownEl.className = '';
                    pullDownEl.querySelector('.pullDownLabel').innerHTML = '下拉刷新...';

                    this.minScrollY = -pullDownOffset;
                } else
                //$(pullDownEl).hide();
                    ;
            } else if (up && this.y < 0) {

                if (FN.page.current == 'productList') {

                    $(pullUpElNew).show();

                    if (this.y < (this.maxScrollY - yLen) && !pullUpElNew.className.match('flip')) {

                        pullUpElNew.className = 'flip';
                        pullUpElNew.querySelector('.line-title span').innerHTML = '向上滑动查看更多兑付期';
                        this.maxScrollY = this.maxScrollY;
                    } else if (this.y > (this.maxScrollY + yLen) && pullUpElNew.className.match('flip')) {
                        pullUpElNew.className = '';
                        pullUpElNew.querySelector('.line-title span').innerHTML = '向上滑动查看更多兑付期';
                        this.maxScrollY = pullUpElNew.offsetHeight;
                    }
                } else {
                    $(pullUpEl).show();
                    if (this.y < (this.maxScrollY - yLen) && !pullUpEl.className.match('flip')) {
                        console.log(3);
                        pullUpEl.className = 'flip';
                        pullUpEl.querySelector('.pullUpLabel').innerHTML = '松手开始更新...';
                        this.maxScrollY = this.maxScrollY;
                    } else if (this.y > (this.maxScrollY + yLen) && pullUpEl.className.match('flip')) {
                        console.log(4);
                        pullUpEl.className = '';
                        pullUpEl.querySelector('.pullUpLabel').innerHTML = '上拉加载更多...';
                        this.maxScrollY = pullUpOffset;
                    } else
                    //$(pullUpEl).hide();
                        ;
                }
            }
        },
        onScrollEnd: function () {
            if (pullDownEl.className.match('flip')) {
                pullDownEl.className = 'loading';
                pullDownEl.querySelector('.pullDownLabel').innerHTML = '加载中...';
                FN.ctrl.get(FN.page.current).scrollDown();
            }
            else if (pullUpEl.className.match('flip')) {
                pullUpEl.className = 'loading';
                pullUpEl.querySelector('.pullUpLabel').innerHTML = '加载中...';
                FN.ctrl.get(FN.page.current).scrollUp();
            } else if (pullUpElNew.className.match('flip')) {
                pullUpElNew.className = 'loading';
                pullUpElNew.querySelector('.line-title span').innerHTML = '加载中...';
                FN.ctrl.get(FN.page.current).scrollUp();
            }
            if (pullDownEl.className == '')
                $(pullDownEl).hide();

            if (pullUpEl.className == '')
                $(pullUpEl).hide();
            if (pullUpElNew.className == '')
                $(pullUpElNew).hide();
            curscrollY = this.y;//滚动结束记录当前最后的Y距离，用于和maxScrollY对比是否滚动到了最底部
        }
    });

    if (FN.debug) {
        //		FN.page.go('investHistory',{id:2000000413,status:1});//投资记录
        //		FN.page.go('banks');//银行列表
        //		$("#myPopupDiv").trigger('create').trigger('refresh').popup()
        //		$("#myPopupDiv").popup('close');
        	FN.page.go('productList');
        //		FN.page.go('myInvest');//我的投资
        //		FN.page.go('productList');//理财产品
        //		FN.page.go('productMore',{page:'1',status:'2'});//更多
        //		FN.page.go('topInvester',{});//排行榜
        /*
         FN.page.go('hongbaorecord', {
         goBackUrl: 'myhongbao',
         page1: 1,
         page2: 1,
         tab: 0
         }, 'load');*/
    }

	  setTimeout(function () {
            //FN.page.go('cunPlanSet','','load');
			//FN.page.go('cunPlanSet',{cunid:6},'load');
			/**
			FN.page.go('paySuccess', {fromurl:'recommend',
					luckyDrawMsg: 'luckyDrawMsg',
					redPackageMsg: 'redPackageMsg',
					huafeiMsg: 'huafeiMsg',
					shareFlow:1,
					friendShareMsg:'friendShareMsg',
					friendShareUrl:"http://192.168.1.128/friendCash/index",
					friendShare:1,
					havePlatformPro:'2'
			}, 'load');**/
		   }, 800);
});
FN.pay = {
    requestCount: 0,
    isPolling: 0,
    doResult: function (data, fail) {

        if (FN.ctrl.exception(data, true)) {
            fail();
            return;
        }
        if (data.error == '0') {

            if (data.result.beginTime) { //起息时间。。
                FN.page.go('paySuccess', {
                    startdate: data.result.beginTime,
                    fromsrc: data.result.productCateId,
                    upid: data.result.userProductId,
                    haveFlow: data.result.haveFlow,
                    flowCount: data.result.flowCount,
                    haveRedEnvelope: data.result.haveRedEnvelope,
                    redEnvelopeAmount: data.result.redEnvelopeAmount,
                    redEnvelopeId: data.result.redEnvelopeId,
                    pubId: data.result.pubId,
                    shareHeader: data.result.shareHeader,
                    shareTitle: data.result.shareTitle,
                    shareIcon: data.result.shareIcon,
                    url: data.result.url,
                    activityUrl: data.result.activityUrl,
                    haveMonthlyInterestActivity: data.result.haveMonthlyInterestActivity,
                    interestTicketRewardShare: data.result.interestTicketRewardShare,
                    currentAmountAttained: data.result.currentAmountAttained,
                    haveInterestTicket: data.result.haveInterestTicket,
                    currentMonthAmount: data.result.currentMonthAmount,
                    monthNeedAmount: data.result.monthNeedAmount,
                    monthMaxAmount: data.result.monthMaxAmount,
                    minInvestAmount: data.result.minInvestAmount,
                    month: data.result.month
                }, 'load');
            } else {
                setTimeout(function () {
                    FN.pay.isPolling = 1;
                    FN.pay.requestCount = 0;
                    FN.pay.pollingRequest(data.result.orderCode);
                }, 4000);
            }
        } else {
            FN.ctrl.smallTip(data.result, 2000);
            FN.native.closeWaitDialog();
            fail();
        }
    },

    pollingRequest: function (orderCode) {
        FN.pay.requestCount++;
        var url = 'api/pay/get_order_status';
        FN.native.get(url, {orderCode:orderCode}, 'get_order_status.get', 'json');
        FN.callbackFunc['get_order_status.get'] = function (data) {
            if (FN.ctrl.exception(data, true))
                return;
            if (data.error == '0') {
                // 购买成功；如果,有返回加息券和流量的话，传递过去提示用户
                FN.pay.isPolling = 0;
                FN.page.go('paySuccess', {
                    startdate: data.result.beginTime,
                    fromsrc: data.result.productCateId,
                    upid: data.result.userProductId,
                    haveFlow: data.result.haveFlow,
                    flowCount: data.result.flowCount,
                    haveRedEnvelope: data.result.haveRedEnvelope,
                    redEnvelopeAmount: data.result.redEnvelopeAmount,
                    redEnvelopeId: data.result.redEnvelopeId,
                    pubId: data.result.pubId,
                    shareHeader: data.result.shareHeader,
                    shareTitle: data.result.shareTitle,
                    shareIcon: data.result.shareIcon,
                    url: data.result.url,
                    activityUrl: data.result.activityUrl,
                    haveMonthlyInterestActivity: data.result.haveMonthlyInterestActivity,
                    interestTicketRewardShare: data.result.interestTicketRewardShare,
                    currentAmountAttained: data.result.currentAmountAttained,
                    haveInterestTicket: data.result.haveInterestTicket,
                    currentMonthAmount: data.result.currentMonthAmount,
                    monthNeedAmount: data.result.monthNeedAmount,
                    monthMaxAmount: data.result.monthMaxAmount,
                    minInvestAmount: data.result.minInvestAmount,
                    month: data.result.month
                }, 'load');

                FN.native.closeWaitDialog();

            } else if (data.error == '2') {
                // 购买失败
                FN.pay.isPolling = 0;
                FN.ctrl.smallTip(data.result, 2000);
                FN.native.closeWaitDialog();
            } else if (data.error == '3') {
                // 重新请求
                setTimeout(function () {
                    if (FN.pay.requestCount == 55) {
                        FN.ctrl.msgTip({
                            title: '支付结果获取中',
                            content: '支付结果获取中，请稍后查看。客服热线：4000-902-903',
                            desc: '确定',
                            event: function () {
                                FN.ctrl.msgTipCtrl(false);
                            }
                        });
                        FN.native.closeWaitDialog();
                        return;
                    }
                    pollingRequest(orderCode);
                }, 2000);
            }
        }
    }
}

//调试的时候，方便弹出html/js错误信息,会自动捕获
/*window.onerror = function(msg, url, line){
 FN.ctrl.smallTip( "真不幸，又出错了\n"
 + "\n错误信息：" + msg
 + "\n所在文件：" + url
 + "\n错误行号：" + line        );
 }*/

/*定时器
 setInterval(function(){
 var deviceWidth = document.body.clientWidth, scale = 0.552;
 viewport = document.querySelector("meta[name=viewport]");
 viewport.setAttribute('content', 'width=device-width, initial-scale=' + scale + ', maximum-scale=' + scale + ', minimum-scale=' + scale + ', user-scalable=0,shrink-to-fit=no');

 },5000)*/