/**
 * 不常修改业务模块
 *  topInvester more pwdManager setLoginPassword setPayPassword aboutMe activityList depositDetial depositUpAsset
 * 
 */

FN.ctrl.set('topInvester', function(params) {
	var getTopInvester = function(bill) {

		//隐藏其他页面的弹窗
		$('#div_feedback').hide();
		//FN.native.openWaitDialog();
		FN.native.get('api/bill/topInvester', {}, 'topInvester.get', 'json');
		FN.callbackFunc['topInvester.get'] = function(data) {
			if (FN.ctrl.exception(data))
				return;
			if (data.error != '1') {
				var user = {
					'user': data.result
				};
				FN.ctrl.show(params.ctrlName, user);
			}
			FN.native.closeWaitDialog();
		}
		params.billGoBackUrl = bill.goBackUrl;
		FN.native.setHead({
			url: bill.goBackUrl,
			title: '投资排行榜'
		});
		FN.native.setNavi({
			show: 0
		});
	}
	return {
		'init': function(data) {
			getTopInvester(data);
		},
		'update': function() {

		}
	}

}).set('more', function(params) {
	var getMore = function() {
		//隐藏首页的div弹窗
		$('#div_feedback').hide();
		$('#yaoqing_convene').hide();
		//隐藏金秋活动动态图
		$('.animation_swing_box').hide();
		FN.index.closeRecommendPop();
		//FN.util.closeuppop();
		FN.native.get('api/my/get_user_info', {}, 'get_user.get', 'json');
		FN.callbackFunc['get_user.get'] = function(data) {
			if (FN.ctrl.exception(data))
				return;
			if (data.result != "NO_TOKEN") {
				params.userPhone = data.result.phone;
				if (data.result.phone) {
					if (data.result.phone.length != 0) {
						FN.user.saveUserInfoData(data);
						data.result.phone = data.result.phone.substring(0, 3) + '****' + data.result.phone.substring(7);
					}
				}
			}

			data.tel = FN.native.readEntry('officialTel', 'string', 'COMMONINFO');
			data.gesture = FN.native.readEntry('gesture', 'string', 'toggle');
			params.data = data;
			FN.ctrl.show(params.ctrlName, {
				'datas': data
			});
		}
		setHeadAndNav();
		FN.native.closeWaitDialog();
	}

	var setHeadAndNav = function() {
		FN.native.setHead({
			title: '更多'
		});
		FN.native.setNavi({
			show: 1,
			tab: 'more'
		});
	}

	return {
		'init': function(data) {
			getMore();
		},
		'update': function(data) {
			//隐藏首页的div弹窗
			$('#hongbao_pop').hide();
			$('#songquan_pop').hide();

			FN.native.get('api/my/get_user_info', {}, 'get_user.get', 'json');
			FN.callbackFunc['get_user.get'] = function(data) {
				params.userPhone = data.result.phone;
				if (data.result.phone) {
					if (data.result.phone.length != 0) {
						FN.user.saveUserInfoData(data);
						data.result.phone = data.result.phone.substring(0, 3) + '****' + data.result.phone.substring(7);
					}
				}

				data.tel = FN.native.readEntry('officialTel', 'string', 'COMMONINFO');
				data.gesture = FN.native.readEntry('gesture', 'string', 'toggle');

				params.data = data;
				FN.ctrl.show(params.ctrlName, {
					'datas': data
				});

			}

			setHeadAndNav();

		},
		'goToAccount': function() {
			FN.page.go('myAccount', params, 'load');
		},
		'goToBank': function() {
			params.type = 0;
			FN.page.go('bankcardManage', params, 'load');
		},
		'goToBankDetail': function() {
			params.type = 0;
			FN.page.go('bankcardManage', params, 'load');
		},
		'goToSetGesture': function() {
			FN.native.more2NativeView('setGesture', JSON.stringify(params.data), "FN.page.go('more','','reload');");
		},
		'goToModifyGesture': function() {
			FN.native.more2NativeView('modifyGesture', JSON.stringify(params.data), "FN.page.go('more','','reload');");
		},
		'goToTel': function() {
			FN.native.more2NativeView('tel', JSON.stringify(params.data), "");
		},
		'goToComment': function() {
			FN.native.more2NativeView('comment', JSON.stringify(params.data), "");
		},
		'goToAbout': function() {
			FN.page.go('aboutMe');
		},
		'goToOnLine': function () {
			if (!window.local_obj) {
				FN.native.callNativeCtrl('onLine','');
			} else {
				FN.native.more2NativeView('onLine', "", "");
			}
		    $('#offmsg').html("");
        },
		'isShowKefu':function(){
			if (!FN.user.getIsLogin()) {
					return false;//未登录不显示
			}
			
			if (!window.local_obj) {
					var iosVersion= ios_verson();
					if(iosVersion == '2.2.8'||iosVersion == '2.2.7'||iosVersion=='2.2.6'||iosVersion=='2.2.5'||iosVersion=='2.1.6'||iosVersion=='2.1.5'||iosVersion=='2.1.4'||iosVersion=='2.1.3'){
						return false;
					}else{
						return true;
					}
			} else {
				var androidVersion=window.local_obj.localversion();
				if (androidVersion != '2.2.1' && 
					androidVersion != '2.2.0' && 
					androidVersion != '2.1.5' && 
					androidVersion != '2.1.4' && 
					androidVersion != '2.1.3' && 
					androidVersion != '2.1.2' && 
					androidVersion != '2.1.1' && 
					androidVersion != '2.1.0' && 
					androidVersion != '2.0.7' && 
					androidVersion != '2.0.8' ) {
					return true;
				}else{
					return false;
				}
			}
		}
	}
}).set('pwdManager', function(params) {
	var getpwdManager = function() {
		FN.util.setGlobelBGColor();

		isSet = FN.native.readEntry('isSetPayPassword', 'string', 'userInfo')
		FN.ctrl.show(params.ctrlName, {
			"isSetPayPassword": isSet
		});
		FN.native.setHead({
			url: 'myAccount',
			title: '密码管理'
		});
		FN.native.setNavi({
			show: 0
		});
		FN.native.closeWaitDialog();
	};

	return {
		'init': function() {
			getpwdManager();
		},
		'update': function() {
			FN.util.setGlobelBGColor();
			FN.native.setHead({
				url: 'myAccount',
				title: '密码管理'
			});
			FN.native.setNavi({
				show: 0
			});
		},
		'setLoginPassword': function() {
			FN.page.go('setLoginPassword', {}, 'load');
		},
		'setPayPassword': function() {
			FN.page.go('setPayPassword', {}, 'load');
		}
	}
}).set('setLoginPassword', function(params) {
	var getLoginPassword = function(data) {
		FN.util.setGlobelBGColor();

		FN.ctrl.show(params.ctrlName);
		FN.native.setHead({
			url: 'pwdManager',
			title: '修改登录密码'
		});
		FN.native.setNavi({
			show: 0
		});
		FN.native.closeWaitDialog();
	};

	return {
		'init': function(data) {
			getLoginPassword(data);
		},
		'update': function() {
			FN.util.setGlobelBGColor();
			FN.native.setHead({
				url: 'pwdManager',
				title: '修改登录密码'
			});
			FN.native.setNavi({
				show: 0
			});
		},
		'commit': function() {
			// 验证
			var old_password = params.dom().find("#old_password").val();
			var password = params.dom().find("#password").val();
			var password2 = params.dom().find("#password2").val();
			if (old_password.length == 0) {
				FN.ctrl.smallTip('请输入原密码');
				return;
			}
			if (!FN.util.checkLoginPassword(password)) {
				FN.ctrl.smallTip('请输入6-20位新密码');
				return;
			}

			if (old_password == password) {
				FN.ctrl.smallTip('请设置一个不同的新密码');
				return;
			}
			if (password != password2) {
				FN.ctrl.smallTip('两次输入的密码不一致');
				return;
			}

			// 加密
			var phone = FN.user.getUserPhone();
			old_password = FN.util.MD5(FN.util.MD5(old_password) + phone.substring(7));
			password = FN.util.MD5(FN.util.MD5(password) + phone.substring(7));

			// 发送请求
			var p = {};
			p.old_password = old_password;
			p.password = password;
			FN.native.post('api/my/reset_psd_by_id', p, 'reset_psd_by_id.post', 'json');
			FN.native.openWaitDialog();
			FN.callbackFunc['reset_psd_by_id.post'] = function(data) {
				if (FN.ctrl.exception(data, true))
					return;

				if (data.error == 0) {
					FN.ctrl.smallTip('操作成功');
					// 跳转页面
					FN.page.go('pwdManager', {}, 'load');
				} else if (data.error == 1) {
					FN.ctrl.smallTip('旧密码不正确！');
				} else {
					FN.ctrl.smallTip('操作失败');
				}
				FN.native.closeWaitDialog();
			}
		}
	}
}).set('setPayPassword', function(params) {
	var getLoginPassword = function(data) {
		FN.util.setGlobelBGColor();
		FN.ctrl.show(params.ctrlName);
		FN.native.setHead({
			url: 'pwdManager',
			title: '修改支付密码'
		});
		FN.native.setNavi({
			show: 0
		});
		FN.native.closeWaitDialog();
	};

	return {
		'init': function(data) {
			getLoginPassword(data);
		},
		'update': function() {
			FN.util.setGlobelBGColor();
			FN.native.setHead({
				url: 'pwdManager',
				title: '修改支付密码'
			});
			FN.native.setNavi({
				show: 0
			});
		},
		'commit': function() {
			// 验证
			var old_password = params.dom().find("#old_password").val();
			var password = params.dom().find("#password").val();
			var password2 = params.dom().find("#password2").val();
			if (old_password.length == 0) {
				FN.ctrl.smallTip('请输入原密码');
				return;
			}
			if (!FN.util.checkLoginPassword(password)) {

				FN.ctrl.smallTip('请输入6-20位新密码');
				return;
			}
			if (old_password == password) {
				FN.ctrl.smallTip('请设置一个不同的新密码');
				return;
			}
			if (password != password2) {
				FN.ctrl.smallTip('两次输入的密码不一致');
				return;
			}

			// 加密
			var phone = FN.user.getUserPhone();
			old_password = FN.util.MD5(FN.util.MD5(old_password) + phone.substring(7));
			password = FN.util.MD5(FN.util.MD5(password) + phone.substring(7));

			// 发送请求
			var p = {};
			p.old_pay_password = old_password;
			p.new_pay_password = password;
			FN.native.post('api/my/reset_paypassword', p, 'reset_paypassword.post', 'json');
			FN.native.openWaitDialog();
			FN.callbackFunc['reset_paypassword.post'] = function(data) {
				if (FN.ctrl.exception(data, true))
					return;

				if (data.error == 0) {
					FN.ctrl.smallTip('操作成功');
					// 跳转页面
					FN.page.go('pwdManager', {}, 'load');
				} else if (data.error == 1) {
					FN.ctrl.smallTip('旧密码不正确！');
				} else {
					FN.ctrl.smallTip('操作失败');
				}
				FN.native.closeWaitDialog();
			}
		}
	}

}).set('aboutMe', function(params) {
	var getAboutMe = function() {

		FN.util.setGlobelBGColor();
		var jsonStr = FN.cache.getEntry('domain_string', 'dict', 1);
		var obj = eval('(' + jsonStr + ')');

		var data = {};
		data.introduce = obj.result.introduce;
		data.officialTel = obj.result.officialTel;
		data.appName = obj.result.appName;
		//		if(!window.local_obj){
		//			data.version = obj.result.iosappVersion;
		//		}else{
		//			data.version = obj.result.androidappVersion;
		//		}
		data.version = FN.native.getLolVerson();

		setTimeout(function() {
			FN.ctrl.show(params.ctrlName, data);
		}, 25);


		FN.native.setHead({
			url: 'more',
			title: '关于我们'
		});
		FN.native.setNavi({
			show: 0
		});

		//FN.native.setHead({title:'存3笔'});
		//FN.native.setNavi({show:1,tab:'recommend'});

		FN.native.closeWaitDialog();

	};

	return {
		'init': function() {
			getAboutMe();
		},
		'update': function() {
			FN.util.setGlobelBGColor();
			FN.native.setHead({
				url: 'more',
				title: '关于我们'
			});
			FN.native.setNavi({
				show: 0
			});
		}
	}

}).set('activityList', function(params) {
	var showActivityListPage = function(data) {
		var fromPage = data.goBackUrl || 'myInvest';
		FN.native.setHead({
			url: fromPage,
			title: '活动专区'
		});
		FN.native.setNavi({
			show: 0
		});
		FN.native.get('api/lottery/home', {from:'activity'}, 'activityList.get', 'json');
		FN.native.openWaitDialog();
		FN.callbackFunc['activityList.get'] = function(data) {
				if (FN.ctrl.exception(data, true))
					return;

				if (data.error == 0) {
					params.data = data.result;
					// 跳转页面
					FN.ctrl.show(params.ctrlName, {
						activitys: data.result
					});
				}
				FN.native.closeWaitDialog();

				setTimeout(function() {
					myScroll.refresh();
				}, 500);
			}
			//定时器,,监控，吧底部的tab 隐藏。。。
		var intvalBug = setInterval(function() {
			if ($('#activityListDiv:visible').length > 0) {
				FN.native.setNavi({
					show: 0
				});
			} else {
				clearInterval(intvalBug);
			}
		}, 500);
	};
	return {
		'init': function(data) {
			showActivityListPage(data);
		},
		'update': function(data) {
			showActivityListPage(data);
		},
		'goToNext': function(index) {
			var activityData = params.data[index];
			if (activityData.status == 2) { // 活动进行中
				if (activityData.urltype == 1) { // 跳相应的App页面
					FN.page.go(activityData.url, '', 'load');
				} else { // webview加载url
					FN.native.loadExternal(activityData.url);
				}
			}
		}
	}
}).set('depositDetial', function(params) {
	var getdepositDetail = function(bill) {
		//FN.native.openWaitDialog();
		params.data = bill;

		//隐藏 我的资产页面顶部tab
		$('#div_head').hide();

		FN.native.get('api/my_invest/invest_deposit_detail', {
			upid: bill.upid
		}, 'depositDetail.get', 'json');
		FN.callbackFunc['depositDetail.get'] = function(data) {

			if (data.error != '1') {

				FN.ctrl.show(params.ctrlName, data.result); //html页面可以通过<%=%>来获取节点;  // data.result--是json中固定返回的节点

				//点击礼物跳转到，，微信分享页面。。抽奖
				params.dom().find('.last-month').click(function() {
					if (!window.local_obj) {
						FN.native.loadExternal(data.result.url, '');
					} else {
						FN.native.loadExternal(data.result.url);
					}

				});
			}

			FN.native.closeWaitDialog();
		}

		FN.native.setHead({
			url: bill.goBackUrl,
			title: '存款详情'
		});
		FN.native.setNavi({
			show: 0
		});

		//定时器,,监控，吧底部的tab 隐藏。。。
		var intvalBug = setInterval(function() {
			if ($('#depositDetial:visible').length > 0) {
				FN.native.setNavi({
					show: 0
				});
			} else {
				clearInterval(intvalBug);
			}
		}, 500);
	}
	return {
		'init': function(data) {
			getdepositDetail(data);
		},
		'update': function() {
			FN.native.setHead({
				url: params.data.goBackUrl,
				title: '存款详情'
			});
			FN.native.setNavi({
				show: 0
			});
		},
		'goToDetail': function(el) {
				FN.page.go_ex(el, 'depositUpAsset', {
					upid: params.data.upid,
					goBackUrl: 'depositDetial'
				}, 'load');
			}
			/*'goToDetail':function(productID,productName){
			 FN.page.go('productDetail',{id:productID,name:productName,goBackUrl:'depositDetial'},'load');
			 }*/
	}
}).set('depositUpAsset', function(params) {
	var getdepositDetail = function(bill) {
		//FN.native.openWaitDialog();
		params.data = bill;

		FN.native.get('api/my_invest/invest_user_product_asset', {
			upid: bill.upid
		}, 'invest_user_product_asset.get', 'json');
		FN.callbackFunc['invest_user_product_asset.get'] = function(data) {
			if (data.error != '1') {

				FN.ctrl.show(params.ctrlName, data.result); //html页面可以通过<%=%>来获取节点
			}
			FN.native.closeWaitDialog();
		}

		FN.native.setHead({
			url: 'depositDetial',
			title: '资产匹配详情'
		});
		FN.native.setNavi({
			show: 0
		});
	}
	return {
		'init': function(data) {
			getdepositDetail(data);
		},
		'update': function() {
				FN.native.setHead({
					url: 'depositDetial',
					title: '资产匹配详情'
				});
				FN.native.setNavi({
					show: 0
				});
			}
			/*'goToDetail':function(productID,productName){
			 FN.page.go('productDetail',{id:productID,name:productName,goBackUrl:'depositDetial'},'load');
			 }*/
	}
});