/**
 * 首页信息
 * recommend、security、
 *
 */
FN.index = {
	hideunLoing: function() {//隐藏体验金弹窗
		$('#div_unloginpop').hide();
	},
	closeUnusePop:function() {
		FN.index.hideunLoing();
		FN.other.experiencebind(false);//一元支付弹窗
	},
	hideyaoqingpop: function() {//隐藏邀请有奖弹窗
		$('#divyaoqing_loginpop').hide();
	},
	closeRecommendPop: function() {//切换其他页签的时候，隐藏首页弹窗口
		$('#divyaoqing_loginpop').hide();
		$('#hongbao_pop').hide();
		$('#songquan_pop').hide();
		$('#divmoney1888pop').hide();
		$('#productList_tip').hide();
		$('#divbirthdaypop').hide();
		$('#divnewbiegiftpop').hide();
	},
	hidemoney1888pop: function() {//隐藏现金1888元活动弹窗
		$('#divmoney1888pop').hide();
	}
}
FN.ctrl.set('recommend', function(params) {
	//重点推荐页面处理逻辑
	var getRecommend = function(bill) {

		//判断是否是刷新当前页面reload过来的，在下面scrolldown中
		if (bill != undefined) {
			params.isscroll = bill.isscroll;
		}

		//隐藏 我的资产页面顶部的tab
		$('#div_head').hide();
		
		//区分Ios？
		if (FN.native.getLolVerson() == '2.1.4' && !window.local_obj) {
			var isDoNologin = FN.cache.getEntry('ios_v214_nologin');
			if (isDoNologin !== true) {
				FN.native.get('api/my_invest/detail', {}, 'test.zjr', 'json');
				FN.callbackFunc['test.zjr'] = function(data) {
					if (data == {}) {
						FN.user.saveToken('', '');
						FN.user.saveLoginStatus(false);
						FN.user.afterLoginData();
						FN.cache.putEntry('ios_v214_nologin', true);
					}
				}
			}
		}

		//FN.native.openWaitDialog();
		$('#songquan_pop').hide();
		$('#div_experienceRule_pop').hide();
		$('#productList_tip').hide();
		FN.util.closefbpop();
		//设置标题和底部tab
		if (params.isscroll != undefined && params.isscroll == 1) {}

		//发送api请求
		FN.native.get('api/bill/recommend', {}, 'recommend.get', 'json');
		FN.callbackFunc['recommend.get'] = function(data) {

			if (FN.ctrl.exception(data))
				return;
			params.data = data.result;
			if(params.data.htmlImage==undefined) params.data.htmlImage=null;
			if(params.data.secondInvestOnline==undefined) params.data.secondInvestOnline=2;//不显示
			if(params.data.friendOnline==undefined) params.data.friendOnline=-1;//无值赋值

			//固定html上顶部的banner高度
			//params.data.bannerheight = Number(window.screen.width) * 240 / 750;
			//params.data.experienceFlag="2";
		
			FN.ctrl.show(params.ctrlName, params.data);


			setTimeout(function() {
				myScroll.refresh();//加载图片重新计算高度
			}, 500);



			//动态计算顶部banner的高度，让页面自动计算整体的高度
			//根据屏幕的宽度和图片固定的高宽计算相对屏幕的高
			//动态计算高度貌似不行；直接写在html上就行；；现在是直接在all.css中适配320px的@media
			//$('.topbanner').attr('style','height:'+Number(window.screen.width)*240/750+'+px');

			//右上角小信封
			getNotice();
				
			//---控制banner和小广播
			//控制顶部banner左右滑动
			if (data.result.activitys != null) {
				if (data.result.activitys.length > 1) {
					var start;
					var end;
					var swiperBan = new Swiper('#swiper-banner', {
						autoplayDisableOnInteraction: false,
						pagination: '.swiper-pagination',
						paginationClickable: true,
						autoplay: 5000,
						speed: 500,
						loop: true,
						onTouchEnd: function(swiper) {
							end = swiper.touches.currentX;

							if (Math.abs(end - start) < 10) {
								//获取地址,不能用swiper-slide，否则多个banner获取的url都是一样的
								//在swiper.css中定义的
								var _url = $('.swiper-slide-active').data('url');

								//进行跳转
								FN.ctrl.get('recommend').goToBannerHuoDong(_url);
							}
						},
						onTouchStart: function(swiper) {
							start = swiper.touches.currentX;
						}
					});
				} else {
					var start;
					var end;
					var swiperBan = new Swiper('#swiper-banner', {
						autoplayDisableOnInteraction: false,
						paginationClickable: false,
						loop: false,
						onTouchEnd: function(swiper) {
							end = swiper.touches.currentX;
							if (Math.abs(end - start) < 10) {
								var _url = $('.swiper-slide').data('url'); //获取地址

								//进行跳转
								FN.ctrl.get('recommend').goToBannerHuoDong(_url);
							}
						},
						onTouchStart: function(swiper) {
							start = swiper.touches.currentX;
						}
					});
				}
			}

			//控制小广播上下滚动
			var swiperNews = new Swiper('#swiper-news', {
				direction: 'vertical',
				autoplay: 4000,
				speed: 500,
				loop: true,
				autoplayDisableOnInteraction: false,
				noSwiping: true,
				noSwipingClass: 'stop-swiping',
			});
			//----

			//针对android设备首页间距单独加载调整
			//通过useragent来区分android还是ios 动态的适配4s和5s首页的高度
			sys = navigator.userAgent.match(/(iPhone|iPod|iPad);?/i) ? 'ios' : 'android';

			var phone = FN.user.getUserPhone(); //是否已登陆
			//(FN.user.getIsLogin())
		
			if (sys == 'ios') {

				//通过高度来判断是否是iPhone 4还是iPhone 5
				isPhone4inches = (window.screen.height == 480);
				isPhone5inches = (window.screen.height == 568);
				isPhone6inches = (window.screen.width == 375);
				isPhone6pinches = (window.screen.width == 414);

				//动态给recomend.html中div添加css
				//if(isPhone4inches)
				//没什么作用
				//$('#div_recomend').addClass('div_recomend');

				//if(isPhone5inches)
				//$('#div_recomend').addClass('div_recomend');

				if (isPhone6inches) {
					if (data.result.topNotices == null || data.result.topNotices.length == 0) {
						//没有小广播，增加高度
						$('.tj-body').addClass('ios4');
						$('.btn-primary.tj-btn').addClass('ios2');
					} else {
						if ((phone == undefined || phone == '')) {
							$('.tj-body').addClass('ios3');
							$('.btn-primary.tj-btn').addClass('ios1');
						} else {
							$('.tj-body').addClass('ios4');
							$('.btn-primary.tj-btn').addClass('ios2');
						}
					}
				}
			} else { //安卓手机

				//由于华为emui和最新的oppo虚拟键在里面，所以判断下手机型号，然后设定特定的css高度
				//否则首页，购买按钮，会被遮盖
				var phonestr = FN.ctrl.get('recommend').getos();
				if (phonestr != '' && phonestr.indexOf('OPPO') > -1) {
					if (phone == undefined || phone == '') {
						//$('.btn-primary.tj-btn').addClass('huaweioppo1');
						$('.tj-body').addClass('huaweioppo3');

						//$('.tj-body').addClass('ios3');
						$('.btn-primary.tj-btn').addClass('ios1');
					} else {
						$('.btn-primary.tj-btn').addClass('android1');
						$('.tj-body').addClass('android3');
					}
				} else if (phonestr != '' && phonestr.indexOf('HUAWEI') > -1) {
					if (phone == undefined || phone == '') {
						$('.tj-body').addClass('huaweioppo3');

						//$('.tj-body').addClass('ios3');
						$('.btn-primary.tj-btn').addClass('ios1');
					} else {
						$('.btn-primary.tj-btn').addClass('android1');
						$('.tj-body').addClass('android3');
					}
				} else {
					//普通安卓
					if (data.result.topNotices == null || data.result.topNotices.length == 0) {
						$('.tj-body').addClass('android4');
						$('.btn-primary.tj-btn').addClass('android2');
					} else {
						$('.btn-primary.tj-btn').addClass('android1');
						$('.tj-body').addClass('android3');
					}
				}
			}
			//-----------------------------------
			//获取外面的scroll div的高度赋值给zdjt 这个div
			//否则首页底部会间隔一段距离。。
			//$('#div_recomend').height($('#scroll').height());

			//判断是否需要更新操作
			if (data.result.androidUpdateFlag == "true") {
				$('#div_update_pop').show();
			}
			//未登录，每天弹窗提示注册送18888体验金
			if (!FN.user.getIsLogin()) {
				var dd = new Date();
				var date = dd.getMonth() + 1 + "." + dd.getDate();
				var isunloginpop = FN.native.readEntry('isunloginpop', 'string', '');

				if (isunloginpop == undefined || isunloginpop == '') {
					FN.native.writeEntry('isunloginpop', date, 'string', '');
					$('#div_unloginpop').show();
				} else if (isunloginpop != date) {
					FN.native.writeEntry('isunloginpop', date, 'string', '');
					$('#div_unloginpop').show();
				}
			}
			//通过后台传递rankOnline否01是来显示现金1888元弹窗
			/*if (FN.user.getIsLogin()) {
				var curphone=FN.user.getUserPhone();//当前登录的手机号码
				var money1888 = FN.native.readEntry('isdivmoney1888pop'+curphone, 'string', '');
				if(params.data.rankOnline!=undefined&&params.data.rankOnline==1){
					if(money1888 == undefined||money1888 ==''){
						$('#divmoney1888pop').show();
						FN.native.writeEntry('isdivmoney1888pop'+curphone, 'divmoney1888', 'string', '');
					}else {
						$('#divmoney1888pop').hide();
					}
				}
			}*/
			//老用户登陆状态，在活动期间弹窗提示一次邀请好友平分5w：同个账号同台设备只谈一次
			if (FN.user.getIsLogin()) {
				if(params.data.friendOnline==1){
					var curphone=FN.user.getUserPhone();//当前登录的手机号码
					var yaoqingpop = FN.native.readEntry('yaoqingpop', 'string', '');
					if (yaoqingpop == undefined || yaoqingpop == '') {
						FN.native.writeEntry('yaoqingpop',curphone, 'string', '');
						$('#divyaoqing_loginpop').show();
					}
					else if(yaoqingpop!=curphone){
						FN.native.writeEntry('yaoqingpop', curphone, 'string', '');
						$('#divyaoqing_loginpop').show();
					}
				}else if(params.data.friendNewOnline!=undefined&&params.data.friendNewOnline==1){
					var curphone=FN.user.getUserPhone();//当前登录的手机号码
					var yaoqingpop = FN.native.readEntry('yaoqingpop2'+curphone, 'string', '');
					if (yaoqingpop == undefined || yaoqingpop == '') {
						FN.native.writeEntry('yaoqingpop2'+curphone,'isyaoqingpop2', 'string', '');
						$('#yaoqing_convene').show();
					}else{
						$('#yaoqing_convene').hide();
					}
				}
			}

			//通过后台传递birthdayUser否01是来显示现金生日弹窗，有生日弹生日，没生日弹框排行榜
			if (FN.user.getIsLogin()) {
				var curphone=FN.user.getUserPhone();//当前登录的手机号码
				if(params.data.birthdayUser!=undefined&&params.data.birthdayUser==1){
					var birthday = FN.native.readEntry('isdivbirthdaypop'+curphone+params.data.birthdayYear, 'string', '');
					if(birthday == undefined||birthday == ''){
						$('#birthdayAge').html(params.data.birthdayAge);
						$('#birthdayName').html('亲爱的' + params.data.birthdayName + '，生日快乐！');
						FN.native.writeEntry('isdivbirthdaypop'+curphone+params.data.birthdayYear, 'divbirthday', 'string', '');
						$('#divbirthdaypop').show();
					}else {
						$('#divbirthdaypop').hide();
						
						//通过后台传递showNewbieGift,1:每天显示2:每周显示新喵福利弹窗
						var curday = FN.util.addDate(0);
						if(params.data.showNewbieGift!=undefined&&params.data.showNewbieGift==1){
							var newbiemiao = FN.native.readEntry('divnewbiemiao1', 'string', '');
							if(newbiemiao == undefined||newbiemiao ==''){
								FN.native.writeEntry('divnewbiemiao1', curphone+curday, 'string', '');
								$('#divnewbiegiftpop').show();
							}else {
								$('#divnewbiegiftpop').hide();
								
								//通过后台传递rankOnline否01是来显示现金1888元弹窗
								FN.ctrl.get('recommend').money1888pop();
							}
						}else if(params.data.showNewbieGift!=undefined&&params.data.showNewbieGift==2){
							var sixDayAfer = FN.util.addDate(6);
							var newbiemiao = FN.native.readEntry('divnewbiemiao2', 'string', '');
							if(newbiemiao == undefined||newbiemiao ==''){
								FN.native.writeEntry('divnewbiemiao2', curphone+sixDayAfer, 'string', '');
								$('#divnewbiegiftpop').show();
							}else {
								var cacheday = newbiemiao.replace(curphone,'');
								if(curday > cacheday) {
									FN.native.writeEntry('divnewbiemiao2', curphone+sixDayAfer, 'string', '');
									$('#divnewbiegiftpop').show();
								}else {
									$('#divnewbiegiftpop').hide();
								
									//通过后台传递rankOnline否01是来显示现金1888元弹窗
									FN.ctrl.get('recommend').money1888pop();
								}
							}
						}else {
							//通过后台传递rankOnline否01是来显示现金1888元弹窗
							FN.ctrl.get('recommend').money1888pop();
						}
					}
				}else {
					//通过后台传递showNewbieGift,1:每天显示2:每周显示新喵福利弹窗
					var curday = FN.util.addDate(0);
					if(params.data.showNewbieGift!=undefined&&params.data.showNewbieGift==1){
						var newbiemiao1 = FN.native.readEntry('divnewbiemiao1'+curphone+curday, 'string', '');
						if(newbiemiao1 == undefined||newbiemiao1 ==''){
							FN.native.writeEntry('divnewbiemiao1'+curphone+curday, 'divnewbiemiao1', 'string', '');
							$('#divnewbiegiftpop').show();
						}else {
							$('#divnewbiegiftpop').hide();
							
							//通过后台传递rankOnline否01是来显示现金1888元弹窗
							FN.ctrl.get('recommend').money1888pop();
						}
					}else if(params.data.showNewbieGift!=undefined&&params.data.showNewbieGift==2){
						var sixDayAfer = FN.util.addDate(6);
						var newbiemiao2 = FN.native.readEntry('divnewbiemiao2'+curphone, 'string', '');
						if(newbiemiao2 == undefined||newbiemiao2 ==''){
							FN.native.writeEntry('divnewbiemiao2'+curphone, curphone+sixDayAfer, 'string', '');
							$('#divnewbiegiftpop').show();
						}else {
							var cacheday = newbiemiao2.replace(curphone,'');
							if(curday > cacheday) {
								FN.native.writeEntry('divnewbiemiao2'+curphone, curphone+sixDayAfer, 'string', '');
								$('#divnewbiegiftpop').show();
							}else {
								$('#divnewbiegiftpop').hide();
							
								//通过后台传递rankOnline否01是来显示现金1888元弹窗
								FN.ctrl.get('recommend').money1888pop();
							}
						}
					}else {
						//通过后台传递rankOnline否01是来显示现金1888元弹窗
						FN.ctrl.get('recommend').money1888pop();
					}
				}
			}
			
			//首页显示中秋节灯笼活动---------------------------
			if(params.data.midAutumnFestivalUrl!=undefined&&params.data.midAutumnFestivalUrl!=''){
			$('.zq_tip').show();
			//手机存储活动url供给产品列表使用
			FN.native.writeEntry('zhongqiu', params.data.midAutumnFestivalUrl, 'string', '');
			//跳转到活动的页面
			/*$('.zq_tip').click(function() {
			//FN.native.loadExternal(params.data.midAutumnFestivalUrl);
			FN.ctrl.get('recommend').goToBannerHuoDong(params.data.midAutumnFestivalUrl);
			});*/
			}else{
			$('.zq_tip').hide();
			//清空存储的活动url，产品列表不再使用
			FN.native.writeEntry('zhongqiu', '', 'string', '');
			}
			//---------------------------
			//首页显示金秋活动送iPhone7---------------------------
			if(params.data.goldAutumnOnline!=undefined&&params.data.goldAutumnOnline==1){
				$('.animation_swing_box').show();
				//手机存储活动url供给产品列表使用
				FN.native.writeEntry('zhongqiunew', params.data.goldAutumnUrl, 'string', '');
			}else{
				$('.animation_swing_box').hide();
				//清空存储的活动url，产品列表不再使用
				FN.native.writeEntry('zhongqiunew', '', 'string', '');
			}
			//---------------------------
		};

		//-----当月投资满20000然后领取加息券接口
		var getquan = function() {
			FN.native.get('api/pay/get_month_interest', {}, 'recommendquan.get', 'json');
			FN.callbackFunc['recommendquan.get'] = function(data) {
				//if(FN.ctrl.exception(data)){
				//return;
				// }
				if (data.error == '0') {
					//隐藏首页的div弹窗
					$('#hongbao_pop').hide();

					//直接跳转到我的加息券
					FN.page.go('myjiaxi', {}, 'load');

				} else {
					FN.ctrl.smallTip(data.result.msg);
				}
			};
		};

		//首页右上角消息获取
		var getNotice = function() {
			FN.native.get('api/notice/index', {}, 'recommend.notice', 'json');
			FN.callbackFunc['recommend.notice'] = function(data) {
				if (data.error == '0') {
					if (data.result.lists.length == 0) {
						params.dom().find('.notice-bar').addClass('hide');
					} else {
						params.dom().find('.notice-bar').removeClass('hide').html(data.result.lists[0].title)
							.click(function() {
								FN.native.loadExternal('api/notice/list?page=1&id=' + data.result.lists[0].id);
								$(this).hide();
							});
					}
				}
				var iconPath = '/tpl/recommend/img/h5_mesg_center_onactive.png';
				if (data.result.count != '0') {
					iconPath = '/tpl/recommend/img/h5_mesg_center_onactive.png';
				}
				params.iconImg = iconPath;

				//设置顶部的右上角的"小信封"
				//设置标题和底部tab
				if (params.isscroll != undefined && params.isscroll == 1) {}
			};
		};

		setHeadAndNavi();
		FN.native.closeWaitDialog();
	}

	//--设置标题和tab
	var setHeadAndNavi = function() {
		FN.native.setNavi({
			'show': 1,
			'tab': 'recommend'
		});

		FN.native.setHead({
			'url': '',
			'title': '重点推荐',
			'icon': {
				'url': 'api/notice/list?page=1',
				'img': params.iconImg,
				'target': 'new'
			} //控制右上角的"小信封"
		});
	}

	return {
		'init': getRecommend,
		'goToDetail': function() {
			FN.page.go('productDetail', {
				id: params.data.id,
				name: params.data.name,
				goBackUrl: 'recommend'
			}, 'load');
		},
		//重点页面,点击，"购买"按钮 上面2行,会跳转到资金保障页面，因为这个页面的数据是详情页面提供的，所以先跳转到详情
		//在转到资金保障页面
		'goToDetailTosecure': function(productType) {

			FN.native.setNavi({
				show: 0
			});

			FN.page.go('productDetail', {
				id: params.data.id,
				name: params.data.name,
				goBackUrl: 'recommend',
				isfromrecommend: 1,
				type: productType
			}, 'load');
		},
		'update': function() {
			FN.util.closefbpop();
			setHeadAndNavi();
			//FN.page.go('recommend', '', 'reload');
			setTimeout(function() {
				myScroll.refresh();//加载图片重新计算高度
			}, 500);

			//体验金相关弹窗隐藏。。。
			$('#div_experienceGet_pop').hide();
			$('#div_experienceSuccess_pop').hide();
			$('#div_experienceError_pop').hide();
			$('#div_experienceRule_pop').hide();
			$('#div_experienceError_pop2').hide();
		},
		/*'scrollUp':function(){
		 //myScroll.refresh();
		 },*/
		'scrollDown': function() {

			/*setTimeout(function () {
			 //console.log("下拉刷新...");
			 myScroll.refresh();
			 }, 1000);*/

			//判断刷新还是跳转到当前页面的话，上面就不重复设置title和tab
			//这样可以兼容首页还没刷新完毕,用户就点击了跳转,页面同时出现首页和目标页面的内容问题
			FN.page.go('recommend', {
				isscroll: 1
			}, 'reload');
		},
		'yaoqing': function() {//打开邀请有奖活动页面
			$('#divyaoqing_loginpop').hide();
			FN.native.loadExternal(params.data.friendUrl);
		},
		'money1888':function(){//打开现金1888元活动页面
			$('#divmoney1888pop').hide();
			FN.native.loadExternal(params.data.rankUrl);
		},
		'money1888pop':function(){//通过后台传递rankOnline否01是来显示现金1888元弹窗
			var curphone=FN.user.getUserPhone();//当前登录的手机号码
			if(params.data.rankOnline!=undefined&&params.data.rankOnline==1){
				var money1888 = FN.native.readEntry('isdivmoney1888pop'+curphone, 'string', '');
				if(money1888 == undefined||money1888 ==''){
					FN.native.writeEntry('isdivmoney1888pop'+curphone, 'divmoney1888', 'string', '');
					$('#divmoney1888pop').show();
				}else {
					$('#divmoney1888pop').hide();
				}
			}
		},
		'yaoqingconvene': function() {//打开邀请有奖活动页面新版邀请好友
			$('#yaoqing_convene').hide();
			FN.native.loadExternal(params.data.friendNewUrl);
		},
		'goTosignUrl': function(signUrl) { //首页签到入口

			FN.native.loadExternal(signUrl);
		},
		'goTofriendUrl': function(friendUrl) { //首页推荐有奖入口
			if(friendUrl !=null&&friendUrl!=''){
				FN.native.loadExternal(friendUrl);
			}			
		},
		'newbiegiftmiao':function(){//打开现金1888元活动页面
			$('#divnewbiegiftpop').hide();
			FN.native.loadExternal(params.data.showNewbieGiftUrl);
		},
		'goToanquan': function(safeUrl) { //首页安全保障入口

			//FN.page.go('security');
			FN.native.loadExternal(safeUrl);

		},
		'goToBannerHuoDong': function(hdurl) { //顶部banner活动跳转
			FN.native.loadExternal(hdurl);
		},
		'handleTopActivityAction': function(type,url) { //顶部banner活动跳转
			if(type == 1){
				FN.page.go(url,{},'load');
				return
			}
			FN.native.loadExternal(url);
			// FN.native.loadExternal("http://zhuaqianmao.com/public/index_renrenche.html");
		},
		'goToBannerUrl': function() { //顶部banner活动跳转--中秋节活动
			FN.native.loadExternal(params.data.midAutumnFestivalUrl);
		},
		'goToMyInvest': function() { //我的投资
			$('#divbirthdaypop').hide();
			FN.page.go('myInvest');
		},
		'goToNotices': function(type, tourl) { //小广播跳转

			if (type == 1) { //我的红包
				FN.page.go('myhongbao', {goBackUrl: 'recommend'}, 'load');
			}
			if (type == 2) { //我的加息券
				FN.page.go('myjiaxi', {goBackUrl: 'recommend'}, 'load');
			}
			if (type == 3) { //转到h5首页
				APP.recommend();
			}
			if (type == 4) { //转到h5产品列表
				APP.pruductList();
			}
			if (type == 5) { //转到h5我的投资页面
				APP.myInvest();
			}
			if (type == 6) { //转到h5更多
				APP.more();
			}
			if(type == 7){
				FN.page.go('myExperience', {
					goBackUrl: 'recommend',
				}, 'load');
			}
			if (type == 11) { //转到外网活动url
				FN.native.loadExternal(tourl);
			}
			if (type == 12) { //只是单纯的公告，点击不做跳转

			}
			if (type == 13) { //点击转到产品列表页面,弹出dialog对话框,介绍抢红包活动快手,压轴，土豪

				FN.page.go('productList', {
					isfrom: 'guangbo'
				}, 'load');
			}
		},
		'getos': function() {
			//获取用户代理
			var ua = navigator.userAgent;
			if (ua.indexOf("Windows NT 5.1") != -1) return "Windows XP";
			if (ua.indexOf("Windows NT 6.0") != -1) return "Windows Vista";
			if (ua.indexOf("Windows NT 6.1") != -1) return "Windows 7";
			if (ua.indexOf("iPhone") != -1) return "iPhone";
			if (ua.indexOf("iPad") != -1) return "iPad";
			if (ua.indexOf("Linux") != -1) {
				var index = ua.indexOf("Android");
				if (index != -1) {
					//os以及版本
					var os = ua.slice(index, index + 13);

					//手机型号
					var index1 = ua.lastIndexOf(";");
					var index2 = ua.indexOf("Build");
					var type = ua.slice(index1 + 1, index2);
					return type + os;
				} else {
					return ""; //Linux
				}
			}

			return ""; //未知操作系统
		},
		'getearnings': function(experienceAmount,experienceAnnualYield,experienceLength) {

			//传递金额年化和收益率
			//FN.other.bindfrom=1;
			//FN.other.gotobindbank('recommend','recommend',params.data.experienceMoneyId);
			FN.page.go('experienceInfo', {Amount:experienceAmount,AnnualYield:experienceAnnualYield,
				expLength:experienceLength,goBackUrl:'recommend'}, 'load');
		},
		'safeguard': function(item) {//安全保障
			if(item>4){
				return;
			}
			var sort=params.data.securityList[item].sort;
			//alert(sort);
			//记录返回时要定位的id
			var curscrollY = '#securityList-image'+item+'';
			FN.native.writeEntry('curscrollrecommend', curscrollY, 'string', 'scrollrecommend');
			FN.page.go('safeguard',{type:item},"load");
		}
	}
}).set('security', function(params) {
	//首页安全保障
	var getsecurity = function() {

		FN.util.setGlobelBGColor();

		//设置security.html最外面的div高度也不行
		//图片需要设置最低高度，页面高度才能计算正确,按照屏幕和图片固定的高度计算比例
		var imgheight = Number((window.screen.width * 0.888 * 0.36036036)) * Number(158 / 240);
		$('.safe-img>img').css('height', imgheight);

		FN.ctrl.show(params.ctrlName);

		FN.native.setHead({
			url: 'recommend',
			title: '安全保障'
		});
		FN.native.setNavi({
			show: 0
		});

		FN.native.closeWaitDialog();

		//获取外面的scroll div的高度赋值给zdjt 这个div
		//否则首页底部会间隔一段距离。。
		//$('.safe').height($('#scroll').height());

		//刷新页面设置高度
		//myScroll.refresh();
	};

	return {
		'init': function() {
			getsecurity();
		},
		'update': function() {
			FN.native.setHead({
				url: 'recommend',
				title: '安全保障'
			});
			FN.native.setNavi({
				show: 0
			});
		}
	};
}).set('safeguard', function(params) {
	var showsafe = function(dataprams) {


		var title="";
		if(dataprams.type==0){
			title='安全理财';
		}else if(dataprams.type==1){
			title='华海承保';
		}else if(dataprams.type==2){
			title='到期100%兑付';
		}else if(dataprams.type==3){
			title='无需充值提现';
		}else{
			title='抓钱猫A轮融资公告';
		}
		FN.native.setHead({
			url: 'recommend',
			title: title
		});
		FN.native.setNavi({
			show: 0
		});
		//FN.native.closeWaitDialog();

		FN.native.get('api/bill/getInvestInfo', {}, 'getInvestInfo.get', 'json');
		//FN.native.openWaitDialog();
		FN.callbackFunc['getInvestInfo.get'] = function(data) {
			if (FN.ctrl.exception(data, true))
				return;

			if (data.error == 0) {
				// 跳转页面
				params.data=data.result;
				params.data.type=dataprams.type;

				FN.ctrl.show(params.ctrlName, params.data); //html页面可以通过<%=%>来获取节点
			}
		}

		setTimeout(function() {
			myScroll.refresh();//加载图片重新计算高度
			myScroll.scrollTo(0,0,0);
		}, 500);
	}
	return {
		'init': function(data) {
			showsafe(data);
		}
	}
});