/*
 * 包含产品列表、详情、支付
 * 
 * productDetail productList productMore  investHistory  
 * 
 * secure secureCar secureJiPiao  securePiaoJuZaiQuan  secureGoods
 */

FN.ctrl.set('productDetail', function(params) {
	//产品详情页面处理逻辑
	var getDetail = function(bill) {
		$('#songquan_pop').hide();

		//title和tab
		params.billName = bill.name;
		params.billGoBackUrl = bill.goBackUrl;
		FN.native.setHead({
			url: bill.goBackUrl,
			title: bill.name
		});
		FN.native.setNavi({
			show: 0
		});

		FN.native.get('api/bill/detail', {
			id: bill.id
		}, 'productDetail.get', 'json');
		FN.cache.putEntry('productId', bill.id);
		FN.callbackFunc['productDetail.get'] = function(data) {
			if (FN.ctrl.exception(data)) {
				return;
			}
			//标识是抢红包活动的产品
			if (data.result.isNewbie == 2) {

				getfeedData(bill.id);

			}

			params.data = data.result;
			params.data.descStr = '';
			params.data.productId = bill.id;
			params.data.minPayAmount = data.result.minAmount;


			//防止页面切换过快导致商品详情页面底部tab来不及隐藏，导致2个页面内容在一起显示错乱
			//判断title是否和当前页面一致，再次隐藏顶部和底部tab
			if(params.ctrlName==FN.page.current) {
				if (data.result.name != params.billName) {
					params.billName = data.result.name;
					FN.native.setHead({
						url: bill.goBackUrl,
						title: params.billName
					});
					FN.native.setNavi({
						show: 0
					});
				}
			}

			//如果是,重点推荐页面，"购买"按钮 上面2行div点击过来的;因为
			//只是需要详情页面的数据；在转到 ，资金保障页面；
			//根据跳转过来的来源，显示/隐藏 详情页面
			if (bill.isfromrecommend == undefined) {

					FN.ctrl.show(params.ctrlName, data.result);

					//设置键盘高度。。。。android需要特殊处理/ios页面会自动缩放
					//这个只需要放在一个高度计算不正确的页面即可,若高度不对，是键盘的高度打乱了页面高度
					//可能会出现页面切换到产品详情的时候，有个闪屏
					if (window.top.local_obj) {
						FN.util.resetBodyHeight();
					}


				//标识是抢红包活动的产品
				if (data.result.isNewbie == 2) {

					$('#qhb_div').click(function() {
						FN.ctrl.get('productDetail').pop();
					});
				}

				FN.native.setCal(data.result.parAmount);
				FN.native.setSaleStatus(params);
				params.dom().find('#produce-detail-op').clone(true).appendTo($('#footer')).removeClass('hide');
				FN.native.closeWaitDialog();
			}
			/* else if(bill.isfromrecommend!=undefined&&(bill.type==4||bill.type==5))
			 {//车宝还是跳转到商品详情
			 FN.ctrl.show(params.ctrlName,data.result);

			 FN.native.setCal(data.result.parAmount);
			 FN.native.setSaleStatus(params);
			 params.dom().find('#produce-detail-op').clone(true).appendTo($('#footer')).removeClass('hide');
			 FN.native.closeWaitDialog();

			 }*/
			//直接跳转到资金保障页面
			else if (bill.isfromrecommend != undefined &&
				(bill.type == 1 || bill.type == 2 || bill.type == 3 || bill.type == 4
				|| bill.type == 5 || bill.type == 6 || bill.type == 7|| bill.type == 9
				|| bill.type == 10|| bill.type == 11)) {
				FN.native.closeWaitDialog();
				FN.ctrl.get('productDetail').goToSecure(params.data.productType, bill.isfromrecommend);
			}
		};

		// 判断购买按钮的文字
		FN.native.setSaleStatus = function(params) {
			if (params.data.saleStatus == 0) {
				//params.dom().find('#submit').text('立即购买');
				params.dom().find('#submit').unbind('click');
				params.dom().find('#submit').click(function() {
					if (FN.user.getIsLogin()) {

						FN.native.openWaitDialog();
						FN.native.get('api/my/get_status', {
							product_id: params.data.productId
						}, 'get_status.get', 'json');
						FN.callbackFunc['get_status.get'] = function(data) {
							if (FN.ctrl.exception(data, true))
								return;
							if (data.error == 0) {
								FN.page.go('payInput', {
									id: params.data.productId,
									goBackUrl: 'productDetail',
									'miniPay': params.data.minPayAmount,
									isNewbie: params.data.isNewbie,
									newbiePayMaxAmount: params.data.newbiePayMaxAmount
								}, 'load');
							} else if (data.error == 1) {
								FN.page.go('phoneNumber', {
									forwardUrl: 'productDetail',
									goBackUrl: 'productDetail',
									type: undefined
								}, 'load');
								FN.native.closeWaitDialog();
							} else if (data.error == 2) {
								if (data.result == 'NON_NEWBIE') {
									FN.ctrl.smallTip('只有新手才能购买该产品', 1500);
								} else if (data.result == 'NO_BILL') {
									FN.ctrl.smallTip('该产品不能购买', 1500);
								} else if (data.result == 'VIP') {
									FN.ctrl.smallTip('VIP专享,历史累计投资满' + params.data.vipLessAmount + '即可抢购哦!', 1500);
								}
								FN.native.closeWaitDialog();
							} else {
								FN.native.closeWaitDialog();
							}
						};

					} else {
						FN.page.go('phoneNumber', {
							forwardUrl: 'productDetail',
							goBackUrl: 'productDetail',
							type: undefined
						}, 'load');
					}
				});
			} else if (params.data.saleStatus == 1) {
				//params.dom().find('#submit').text('即将开抢');
				params.dom().find('#submit').unbind("click");
			} else if (params.data.saleStatus == 2) {
				//params.dom().find('#submit').text('已售罄');
				params.dom().find('#submit').unbind("click");
			} else if (params.data.saleStatus == 3) {
				//params.dom().find('#submit').text('已售罄');
				params.dom().find('#submit').unbind("click");
			} else if (params.data.saleStatus == 4) {
				//params.dom().find('#submit').text('已兑付');
				params.dom().find('#submit').unbind("click");
			}
		}

		// 计算器
		FN.native.setCal = function(parAmount) {
			var $scope = {};
			$scope.produce = {
				rate: params.data.annualYield / 100,
				aliRate: params.data.yuebaoRate / 100,
				bankRate: params.data.bankRate / 100,
				fixedDay: params.data.length,
				inputMoney: 10000
			};
			params.dom().find("#produce_inputMoney").val($scope.produce.inputMoney);

			//$("#produce_fixedDay").html($scope.produce.fixedDay);
			$scope.calc = function() {
				$scope.earnings = {
					zqm: ($scope.produce.inputMoney * $scope.produce.rate / 365 * $scope.produce.fixedDay).toFixed(3),
					ali: ($scope.produce.inputMoney * $scope.produce.aliRate / 365 * $scope.produce.fixedDay).toFixed(3),
					bank: ($scope.produce.inputMoney * $scope.produce.bankRate / 365 * $scope.produce.fixedDay).toFixed(3)
				};

				params.dom().find("#earnings_ali_percent").css({
					width: $scope.earnings.ali / $scope.earnings.zqm * 100 + '%'
				})
				params.dom().find("#earnings_bank_percent").css({
					width: $scope.earnings.bank / $scope.earnings.zqm * 100 + '%'
				})
				var value1=$scope.earnings.zqm;
				var value2=$scope.earnings.ali;
				var value3= $scope.earnings.bank;

				params.dom().find("#earnings_zqm_value").html('￥' +value1.substring(0,value1.lastIndexOf('.')+3));
				params.dom().find("#earnings_ali_value").html('￥' + value2.substring(0,value2.lastIndexOf('.')+3));
				params.dom().find("#earnings_bank_value").html('￥' +value3.substring(0,value3.lastIndexOf('.')+3));
			}
			$scope.calc()

			params.dom().find("#produce_inputMoney").bind('input propertychange', function() {
				$scope.produce.inputMoney = $(this).val();
				$scope.calc()
			});

			$scope.show = function(status) {
				if (arguments.length > 0) {
					params.dom().find(".modal-mask")[status]()

				} else {
					if (params.dom().find(".modal-mask").css('display') != "none") {
						params.dom().find(".modal-mask").hide()
					} else {
						params.dom().find(".modal-mask").show()
					}
				}
			};
			params.dom().find("#calc").on('click', function() {
				$scope.show('show')
			});
			params.dom().find("#close").on('click', function() {
				$scope.show('hide')
			})
		};

		FN.native.changeTop = function() {
			params.dom().find(".modal").addClass('changeToTop');
		};

		FN.native.changeDown = function() {
			params.dom().find(".modal").removeClass('changeToTop');
		};

		// 输入金额小于可投金额
		FN.native.checkField = function(value) {
			if (value > params.data.parAmount) {
				params.dom().find('#produce_inputMoney').val(params.data.parAmount);
			}
		}
	}

	/*title和tab*/
	var setHeadAndNavi = function() {
		FN.native.setHead({
			url: params.billGoBackUrl,
			title: params.billName
		});
		FN.native.setNavi({
			show: 0
		});
	}

	//抢红包活动
	var getfeedData = function(pid) {
		FN.native.get('api/bill/redPackage', {
			id: pid
		}, 'redPackage.get', 'json');
		FN.callbackFunc['redPackage.get'] = function(data) {
			if (data.error == "0") {

				var res = data.result;
				if (res.saleStatus == 0 || res.saleStatus == 1) {

					$('#div_fead1').html('拼速度！奖励当前标的首位投资用户<span>' + res.firstAmount + '</span>元红包');

					$('#div_fead2').html('完美压轴！奖励当前标的最后一位投资用户<span>' + res.lastAmount + '</span>元红包');

					if (res.maxBuyAmount == 0) {
						$('#div_fead3').html('求土豪！奖励当前标的累计投资额最高的用户<span>' + res.maxAmount + '</span>元红包');
					} else {
						$('#div_fead3').html('求土豪！奖励当前标的累计投资额最高的用户<span>' + res.maxAmount + '</span>元红包，当前最高累计投资额<span>' + res.maxBuyAmount + '</span>元');
					}

				} else {

					$('#div_fead1').html('<span>' + res.firstName + '</span>最先投资获得<span>' + res.firstAmount + '</span>元现金<br/>红包');
					$('#div_fead2').html('<span>' + res.lastName + '</span>最后投资获得<span>' + res.lastAmount + '</span>元现金<br/>红包');
					$('#div_fead3').html('<span>' + res.maxName + '</span>投资最高获得<span>' + res.maxAmount + '</span>元现金<br/>红包');
				}

				//进入抢红包活动标,每天自动弹出一次弹窗提示（任意进入一个了当天就不弹了）
				/*var mydate = new Date();
				 var toyear = mydate.getFullYear();
				 var tomonth = mydate.getMonth() + 1 ;
				 var today = mydate.getDate();//getday
				 var daystr=toyear+'-'+tomonth+'-'+today;

				 //获取是否存储过，并且是否等于当天日期
				 var isdaypop = FN.native.readEntry('isdaypop', 'string', 'huodongproduct');
				 if(isdaypop==undefined||isdaypop==''||daystr!=isdaypop)
				 {
				 $('#div_feedback').show();
				 FN.native.writeEntry('isdaypop',daystr,'string','huodongproduct');
				 }
				 else
				 {
				 $('#div_feedback').hide();
				 }*/

			}
		}
	}

	return {
		'init': getDetail,
		'update': function(data) {
			params.dom().find('#produce-detail-op').clone(true).appendTo($('#footer')).removeClass('hide');
			setHeadAndNavi();
			if (data && data.action && (data.action == 'login' || data.action == 'register')) {
				FN.native.openWaitDialog();
				setTimeout(function() {

					FN.native.get('api/my/get_status', {
						product_id: params.data.productId
					}, 'get_update_status.get', 'json');
					FN.callbackFunc['get_update_status.get'] = function(data) {

						if (FN.ctrl.exception(data, true))
							return;
						if (data.error == 0) {
							FN.page.go('payInput', {
								id: params.data.productId,
								goBackUrl: 'productDetail',
								'miniPay': params.data.minPayAmount,
								isNewbie: params.data.isNewbie,
								newbiePayMaxAmount: params.data.newbiePayMaxAmount
							}, 'load');
						} else if (data.error == 1) {
							FN.page.go('phoneNumber', {
								forwardUrl: 'productDetail',
								goBackUrl: 'productDetail',
								type: undefined
							}, 'load');
						} else if (data.error == 2) {
							if (data.result == 'NON_NEWBIE') {
								FN.ctrl.smallTip('只有新手才能购买该产品', 1500);
							} else if (data.result == 'NO_BILL') {
								FN.ctrl.smallTip('该产品不能购买', 1500);
							} else if (data.result == 'VIP') {
								FN.ctrl.smallTip('VIP专享,历史累计投资满' + params.data.vipLessAmount + '即可抢购哦!', 1500);
							}

						}

						FN.native.closeWaitDialog();
					};
				}, 800);
			}
			myScroll.refresh();
		},
		'goToBanks': function() {
			FN.page.go('banks', {
				goBackUrl: 'productDetail'
			}, 'load');
		},
		'goToInvestHistory': function() {
			FN.page.go('investHistory', {
				id: params.data.id,
				status: params.data.status
			}, 'load');
		},
		'goToSecure': function(productType, isfromrecommend) {			
			if(params.data.securityImgUrl==undefined) params.data.securityImgUrl="http://s.xiaojinniu.com/protocol/picc.jpg";
			if(params.data.securityDesc==undefined) params.data.securityDes=" 所有在抓钱猫理财平台交易过程中的资金都享受华海保险的账户资金交易安全保障";
			if (productType == 6 || productType == 7) { //资金保障4页面

				if (params.data.protocolImgs.length != 0) {
					var protocolImgs = params.data.protocolImgs.split(',');
					params.data.protocolImgsArray = protocolImgs;
				}
				//productType 6直接从recomentd跳转到“资金保障”页面
				params.data.from = isfromrecommend ? 'recommend' : 'productDetail';
				FN.page.go('secureJiPiao', params.data, 'load');
			} else if (productType == 2) { //资金保障3页面

				if (params.data.protocolImgs.length != 0) {
					var protocolImgs = params.data.protocolImgs.split(',');
					params.data.protocolImgsArray = protocolImgs;
				}
				//productType 1，2，3直接从recomentd跳转到“资金保障”页面
				params.data.from = isfromrecommend ? 'recommend' : 'productDetail';
				FN.page.go('securePiaoJuZaiQuan', params.data, 'load');
			} else if (productType == 4 || productType == 5) {
				if (params.data.verifyImgs.length != 0) {
					var verifyImgs = params.data.verifyImgs.split(',');
					params.data.verifyImgsArray = verifyImgs;
				}
				if (params.data.protocolImgs.length != 0) {
					var protocolImgs = params.data.protocolImgs.split(',');
					params.data.protocolImgsArray = protocolImgs;
				}

				//productType4,5直接到详情页
				// params.data.from ='productDetail';
				params.data.from = isfromrecommend ? 'recommend' : 'productDetail';
				FN.page.go('secureCar', params.data, 'load');
			} else if (productType == 8||productType == 9||productType == 10||productType == 11) { //跳转到质押担保页面(保理项目)
				if (params.data.protocolImgs.length != 0) {
					var protocolImgs = params.data.protocolImgs.split(',');
					params.data.protocolImgsArray = protocolImgs;
				}
				params.data.from = isfromrecommend ? 'recommend' : 'productDetail';
				params.data.productType =productType;//保理项目公用一个资产页面,用于区分页面上内容显示
				FN.page.go('secureGoods', params.data, 'load');
			} else {
				//productType 1，2，3直接从recomentd跳转到“资金保障”页面
				params.data.from = isfromrecommend ? 'recommend' : 'productDetail';
				FN.page.go('secure', params.data, 'load');
			}

		},
		'pop': function() {
			$('#qhbtitle_div').hide();
			$('#div_feedback').show();
		},

		/*'scrollUp':function(){
		 myScroll.refresh();
		 },*/
		/*'scrollDown':function(){

		 myScroll.refresh();
		 }*/
	}

}).set('investHistory', function(params) {
	//产品投资记录页面
	var getInvestHistory = function(bill) {
		//FN.native.openWaitDialog();
		FN.native.get('api/bill/investerInfo', {
			id: bill.id,
			bs: bill.status
		}, 'investHistory.get', 'json');
		FN.callbackFunc['investHistory.get'] = function(data) {
			if (FN.ctrl.exception(data))
				return;
			if (data.error != '1') {
				var user = {
					'user': data.result
				};
				FN.ctrl.show(params.ctrlName, user);
			}
			FN.native.closeWaitDialog();
		}
		FN.native.setHead({
			url: 'productDetail',
			title: '投资记录'
		});
		FN.native.setNavi({
			show: 0
		});
	}

	return {
		'init': function(data) {
			getInvestHistory(data);
		},
		'update': function() {
			FN.native.setHead({
				url: 'productDetail',
				title: '投资记录'
			});
			FN.native.setNavi({
				show: 0
			});
		}
	}

}).set('productList', function(params) {
	var getProductList = function(bill) {
		//隐藏首页的div弹窗
		FN.index.closeRecommendPop();
		//隐藏 我的资产页面顶部tab
		$('#div_head').hide();
		$('#yaoqing_convene').hide();
		FN.util.closeuppop();
		//记住页数,由于页面要显示两个链接,所以要先通过判断页数来加载链接,否则会出错
		params.page =1;
		
		//记录是否要刷新
		params.goType='';
		FN.native.get('api/bill/list_info_new', {}, 'productList.get', 'json');
		FN.callbackFunc['productList.get'] = function(data) {
			if (FN.ctrl.exception(data))
				return;
			if (data.error == '0') {
				data.result.page = 1;
				params.data = data.result;
                FN.ctrl.show(params.ctrlName,data.result);

				//首页显示中秋节灯笼活动---------------------------
				if(params.data.midAutumnFestivalUrl!=undefined&&params.data.midAutumnFestivalUrl!=''){
					$('.zq_tip').show();
					//手机存储活动url供给产品列表使用
					FN.native.writeEntry('zhongqiu', params.data.midAutumnFestivalUrl, 'string', '');
					//跳转到活动的页面
					/*$('.zq_tip').click(function() {
					 //FN.native.loadExternal(params.data.midAutumnFestivalUrl);
					 FN.ctrl.get('recommend').goToBannerHuoDong(params.data.midAutumnFestivalUrl);
					 });*/
				}else{
					$('.zq_tip').hide();
					//清空存储的活动url，产品列表不再使用
					FN.native.writeEntry('zhongqiu', '', 'string', '');
				}
				//---------------------------


				//判断是否是首页广播跳转过来的，然后弹出活动介绍
				//新人始终不弹窗，后台传递一个区分是否新手的字段
				if (data.result.isShowNewbie == 0) //0否 1是
				{

					$('#qhbtitle_div').show();

					$('#div_fead1').html('拼速度！奖励每个活动标的的首位投资用户<span>5</span>元红包');

					$('#div_fead2').html('完美压轴！奖励每个活动标的的最后一位投资用户<span>10</span>元红包');

					$('#div_fead3').html('求土豪！奖励每个活动标的的累计投资额最高的用户<span>30</span>元红包');

					if (bill != undefined && bill.isfrom == 'guangbo') {

						$('#div_feedback').show();
					} else { //其他页面来的总共只弹一次
						var isqhbpop = FN.native.readEntry('isqhbpop', 'string', 'huodonglist');
						if (isqhbpop == undefined || isqhbpop == '') {
							$('#div_feedback').show();
							FN.native.writeEntry('isqhbpop', '1', 'string', 'huodonglist');
						}

					}
				}

                //在产品列表页显示固定的图片
                if(params.data.rankOnline!=undefined&&params.data.rankOnline==1){
					$('#productList_tip').show();
					$("#productList_tip").addClass('animation_1');
				    $(".float_1").removeClass('pull_2');
                    //手机存储活动url供给产品列表使用
                    FN.native.writeEntry('productList-tip', params.data.rankUrl, 'string', '');
                }else{
                    $('#productList_tip').hide();
                    //清空存储的活动url，其他页面不再使用
                    FN.native.writeEntry('productList-tip', '', 'string', '');
                }

                //在产品列表页显示金秋节送iPhone7活动---------------------------
                if(params.data.goldAutumnOnline!=undefined&&params.data.goldAutumnOnline==1){
					$('.animation_swing_box').show();
					//手机存储活动url供给产品列表使用
					FN.native.writeEntry('zhongqiunew', params.data.goldAutumnUrl, 'string', '');
				}else{
					$('.animation_swing_box').hide();
					//清空存储的活动url，产品列表不再使用
					FN.native.writeEntry('zhongqiunew', '', 'string', '');
				}
				//---------------------------
				/********************************红包雨挂饰开始************************/
				if (params.data.redRainOnline != undefined && params.data.redRainOnline == 1) {
					$('.redPacket_rain_tip').show();
					//手机存储活动url供给产品列表使用
					FN.native.writeEntry('redPacketRain', params.data.redRainUrl, 'string', '');
				} else {
					$('.redPacket_rain_tip').hide();
					//清空存储的活动url，产品列表不再使用
					FN.native.writeEntry('redPacketRain', '', 'string', '');
				}
				/********************************红包雨挂饰结束************************/

				//加载圆圈动画效果方法
				huodongAmintion();
			}
		};

		var iconImg = '/tpl/productList/img/top_invester.png';
		params.iconImg = iconImg;
		FN.native.setHead({
			title: '理财产品',
			'icon': {
				"url": "FN.page.go('topInvester',{'goBackUrl':'productList'},'load')",
				'img': params.iconImg,
				'target': 'self'
			}
		});
		FN.native.setNavi({
			show: 1,
			tab: 'productList'
		});
		setTimeout(function() {
			myScroll.refresh();
		}, 500);
		FN.native.closeWaitDialog();




	};
	//动态效果方法(圆圈加载)
	var huodongAmintion = function(){
		$('[data-percent]').each(function(){

			var _percent = $(this).data('percent');

			var _foregroundColor = "#ec574e";

			if(_percent === 0){

				_foregroundColor = "#cecece"
			}

			$(this).circliful({
				animationStep: 3,
				foregroundBorderWidth: 4,
				backgroundBorderWidth: 4,
				percent: _percent,
				foregroundColor: _foregroundColor,   //圆圈的前景色
				backgroundColor: "#cecece"
			});
		});
	};
	return{
		'init': function(bill) {
			getProductList(bill);
		},
		'update': function() {
			//隐藏首页的div弹窗
			$('#hongbao_pop').hide();
			$('#songquan_pop').hide();
			//体验金相关弹窗
			$('#div_experienceGet_pop').hide();
			$('#div_experienceSuccess_pop').hide();
			$('#div_experienceError_pop').hide();
			$('#div_experienceRule_pop').hide();
			FN.util.closefbpop();
			if(params.goType=='isUpdate'){
				FN.page.go('productList', '', 'load');
			}
			FN.native.setHead({
				title: '理财产品',
				icon: {
					url: "FN.page.go('topInvester',{'goBackUrl':'productList'},'reload')",
					'img': params.iconImg,
					'target': 'self'
				}
			});
			FN.native.setNavi({
				show: 1,
				tab: 'productList'
			});

			setTimeout(function() {
				myScroll.refresh();
			}, 500);

			//首页显示中秋节灯笼活动---------------------------
			if(params.data.midAutumnFestivalUrl!=undefined&&params.data.midAutumnFestivalUrl!=''){
				$('.zq_tip').show();
				//手机存储活动url供给产品列表使用
				FN.native.writeEntry('zhongqiu', params.data.midAutumnFestivalUrl, 'string', '');

			}else{
				$('.zq_tip').hide();
				//清空存储的活动url，产品列表不再使用
				FN.native.writeEntry('zhongqiu', '', 'string', '');
			}
            //在产品列表页显示固定的图片
            if(params.data.rankOnline!=undefined&&params.data.rankOnline==1){
                $('#productList_tip').show();
				$("#productList_tip").addClass('animation_1');
				$(".float_1").removeClass('pull_2');
                //手机存储活动url供给产品列表使用
                FN.native.writeEntry('productList-tip', params.data.rankUrl, 'string', '');
            }else{
                $('#productList_tip').hide();
                //    //清空存储的活动url，其他页面不再使用
                FN.native.writeEntry('productList-tip', '', 'string', '');
            }
			//---------------------------
			//在产品列表页显示金秋送iPhone7活动---------------------------
			if(params.data.goldAutumnOnline!=undefined&&params.data.goldAutumnOnline==1){
				$('.animation_swing_box').show();
				//手机存储活动url供给产品列表使用
				FN.native.writeEntry('zhongqiunew', params.data.goldAutumnUrl, 'string', '');

			}else{
				$('.animation_swing_box').hide();
				//清空存储的活动url，产品列表不再使用
				FN.native.writeEntry('zhongqiunew', '', 'string', '');
			}
			/********************************红包雨挂饰开始************************/
			if (params.data.redRainOnline != undefined && params.data.redRainOnline == 1) {
				$('.redPacket_rain_tip').show();
				//手机存储活动url供给产品列表使用
				FN.native.writeEntry('redPacketRain', params.data.redRainUrl, 'string', '');
			} else {
				$('.redPacket_rain_tip').hide();
				//清空存储的活动url，产品列表不再使用
				FN.native.writeEntry('redPacketRain', '', 'string', '');
			}
			/********************************红包雨挂饰结束************************/

		},
		'goToBannerHuoDong': function() { //顶部banner活动跳转hdurl
		FN.native.loadExternal('http://192.168.1.128/midAutumnFestival/index');
		},
		'goToPhoneNumber':function(){
			//设置在返回时加载数据标签
			params.goType = 'isUpdate';
			FN.page.go('phoneNumber', {
				'forwardUrl': 'productList',
				'goBackUrl': 'productList',
				'type': 'experience',
			}, 'load');

		},
		//已兑付第一页进入详情页方法(由于数据是第一页加载的,要另写方法,否则会与第二页加载链接数据冲突)
		'goToProductListNew':function(el,id,name){
			//设置返回加载标签为空
			params.goType = '';
			//var proScroll3 = '#productList'+id+'';
			FN.native.writeEntry('curscrollproductListNew', curscrollY, 'string', 'curscrollproductListNew');
			FN.page.go('productDetail',{id:id,name:name,goBackUrl:'productList'},'load');
		},
		'goToProductSellOut':function(id,name){
			//设置返回加载标签为空
			params.goType = '';
			//获取每个列表的id,在返回时定位到原来的位置
			var proScroll2 = '#productList'+id+'';
			FN.native.writeEntry('curscrollproductList', proScroll2, 'string', 'curscrollproductList');
			FN.page.go('productDetail',{id:id,name:name,goBackUrl:'productList'},'load');
		},
		'goToProductSell':function(el,id,name){
			//设置返回加载标签为空
			params.goType = '';
			//获取每个列表的id,在返回时定位到原来的位置
			FN.native.writeEntry('curscrollproductListNew', curscrollY, 'string', 'curscrollproductListNew');
			FN.page.go('productDetail',{id:id,name:name,goBackUrl:'productList'},'load');
		},
		//进入体验金页面
		'goToExperience':function(){
			//设置在返回时加载数据标签
			FN.other.bindfrom=2;
			params.goType = 'isUpdate';
			FN.other.gotobindbank('productList','productList',params.data.experienceMoney.id);
		},
		'goToMsg':function(){
			FN.ctrl.smallTip('只有新人注册才能获得体验金哦')
		},
		'floatanimation':function(){
			    $("#productList_tip").removeClass('animation_1');
				$(".float_1").addClass('pull_2');
			
			
				setTimeout(function() {
					FN.ctrl.productListtipshow();

				}, 1000);

		},
		'scrollDown': function() {
			FN.page.go('productList', '', 'reload');
		},
		'scrollUp':function(){
			if(params.page==1){
				$('#productListNew').removeClass('hide');
				$('#productListNew').show();
				myScroll.refresh();
				params.page=2;
				//上来加载后定位到已兑付第一条数据方法
				myScroll.scrollToElement('#productListNew',1000);
			}else{
				FN.native.get('api/bill/pageRepayments', {
					page: params.page
				}, 'productMore.get', 'json');
				FN.callbackFunc['productMore.get'] = function(data) {
					if (FN.ctrl.exception(data))
						return;
					if(data.error =='0'){
						data.result.page = 2;
						FN.ctrl.append($('#productListNewMore'), params.ctrlName, data.result, '<!content!>');
						myScroll.refresh();
						params.page++;
						var proScroll1 = '#productListNew'+data.result.billRepayments[0].id+'';
						//上来加载定位到已兑付每页第一条数据方法
						myScroll.scrollToElement(proScroll1,1000);
					}
				};
			}
		}
	}
}).set('productMore', function(params) {
	var getProductMore = function(bill) {
		//FN.native.openWaitDialog();
		FN.native.get('api/bill/page', {
			page: bill.page,
			status: bill.status
		}, 'productMore.get', 'json');
		FN.callbackFunc['productMore.get'] = function(data) {

			if (FN.ctrl.exception(data))
				return;

			FN.ctrl.show(params.ctrlName, {
				bills: data.result,
				listClass: bill.status == '2' ? 'gery' : 'yellow'
			});

			myScroll.scrollTo(0, 0, 0);

			FN.native.closeWaitDialog();
		}
		params.billStatus = bill.status;
		params.billPage = bill.page;
		params.nextPage = 1;
		if (params.billStatus == '2') {
			FN.native.setHead({
				url: 'productList',
				title: '已售罄产品',
				icon: {
					url: "FN.page.go('topInvester',{'goBackUrl':'productMore'},'load')",
					img: '/tpl/productMore/img/top_invester.png',
					target: 'self'
				}
			});
		} else if (params.billStatus == '4') {
			FN.native.setHead({
				url: 'productList',
				title: '已兑付产品',
				icon: {
					url: "FN.page.go('topInvester',{'goBackUrl':'productMore'},'load')",
					img: '/tpl/productMore/img/top_invester.png',
					target: 'self'
				}
			});
		}
		FN.native.setNavi({
			show: 0
		});
	};
	return {
		'init': function(bill) {
			getProductMore(bill);
		},
		'update': function() {
			FN.util.closefbpop();
			if (params.billStatus == '2') {
				FN.native.setHead({
					url: 'productList',
					title: '已售罄产品',
					icon: {
						url: "FN.page.go('topInvester',{'goBackUrl':'productMore'},'load')",
						img: '/tpl/productMore/img/top_invester.png',
						target: 'self'
					}
				});
			} else if (params.billStatus == '4') {
				FN.native.setHead({
					url: 'productList',
					title: '已兑付产品',
					icon: {
						url: "FN.page.go('topInvester',{'goBackUrl':'productMore'},'load')",
						img: '/tpl/productMore/img/top_invester.png',
						target: 'self'
					}
				});
			}
			FN.native.setNavi({
				show: 0
			});
		},
		'scrollDown': function() {
			params.billPage = '1';
			FN.page.go('productMore', {
				page: '1',
				status: params.billStatus
			}, 'reload');
		},
		'scrollUp': function() {
			//FN.ctrl.append($('.produce-list'),'productMore')
			FN.native.get('api/bill/page', {
				page: (parseInt(params.billPage) + params.nextPage) + '',
				status: params.billStatus
			}, 'productMore.append', 'json');
			FN.callbackFunc['productMore.append'] = function(data) {
				if (FN.ctrl.exception(data, true))
					return;
				if (data.result.length > 0) {
					params.nextPage += 1;
					FN.ctrl.append($('#product-more-list'), params.ctrlName, {
						bills: data.result,
						listClass: params.billStatus == '2' ? 'gery' : 'yellow'
					}, '<!content!>');
					FN.native.closeWaitDialog();
				} else
					myScroll.refresh();
			}
		}
	}
}).set('secure', function(params) {
	var init = function(bill) {
		FN.ctrl.show(params.ctrlName, bill);

		addObserver();

		setHeadAndNavi(bill.from);

		FN.native.closeWaitDialog();
		FN.native.adjustAppHeight();
	};

	var addObserver = function() {
		var ndImg = document.getElementById('secure_loadImg');
		ndImg.addEventListener('load', function() {
			myScroll.refresh();
		});
	}

	var setHeadAndNavi = function(from) {

		if (from == 'recommend')
			FN.native.setHead({
				url: 'recommend',
				title: '资金保障'
			});
		else
			FN.native.setHead({
				url: 'productDetail',
				title: '资金保障'
			});
		FN.native.setNavi({
			show: 0
		});
	}

	return {
		'init': init,
		'update': function() {
			setHeadAndNavi();

		}
	}
}).set('secureCar', function(params) {
	var init = function(bill) {
		FN.ctrl.show(params.ctrlName, bill);

		addObserver();
		setHeadAndNavi(bill.from);
		FN.native.closeWaitDialog();
	};

	var addObserver = function() {
		var vImgs = document.getElementsByClassName('verifyImgs_loadImg');
		var pImgs = document.getElementsByClassName('protocolImgs_loadImg');
		for (var i = 0; i < vImgs.length; i++) {
			vImgs[i].addEventListener('load', function() {
				myScroll.refresh();
			});
		}
		for (var i = 0; i < pImgs.length; i++) {
			pImgs[i].addEventListener('load', function() {
				myScroll.refresh();
			});
		}
	}

	var setHeadAndNavi = function(from) {
		if (from == 'recommend')
			FN.native.setHead({
				url: 'recommend',
				title: '资金保障'
			});
		else
			FN.native.setHead({
				url: 'productDetail',
				title: '资金保障'
			});
		FN.native.setNavi({
			show: 0
		});
	}

	return {
		'init': init,
		'update': function() {
			setHeadAndNavi();
		}
	}
}).set('secureJiPiao', function(params) {
	var init = function(bill) {

		//show里面会读取,本地securePiaoJuZaiQuan.html内容替换显示
		FN.ctrl.show(params.ctrlName, bill);

		addObserver();

		setHeadAndNavi(bill.from);

		FN.native.closeWaitDialog();
	};

	//详情页面传递过来的图片数据。。
	var addObserver = function() {
		var pImgs = document.getElementsByClassName('protocolImgs_loadImg');

		for (var i = 0; i < pImgs.length; i++) {
			pImgs[i].addEventListener('load', function() {
				myScroll.refresh();
			});
		}
	}

	var setHeadAndNavi = function(from) {
		if (from == 'recommend')
			FN.native.setHead({
				url: 'recommend',
				title: '资金保障'
			});
		else
			FN.native.setHead({
				url: 'productDetail',
				title: '资金保障'
			});
		FN.native.setNavi({
			show: 0
		});
	}

	return {
		'init': init,
		'update': function() {
			setHeadAndNavi();
		}
	}
}).set('securePiaoJuZaiQuan', function(params) {
	var init = function(bill) {

		//show里面会读取,本地securePiaoJuZaiQuan.html内容替换显示
		FN.ctrl.show(params.ctrlName, bill);

		addObserver();

		setHeadAndNavi(bill.from);

		FN.native.closeWaitDialog();
	};

	var addObserver = function() {
		var pImgs = document.getElementsByClassName('protocolImgs_loadImg');

		for (var i = 0; i < pImgs.length; i++) {
			pImgs[i].addEventListener('load', function() {
				myScroll.refresh();
			});
		}
	}

	var setHeadAndNavi = function(from) {
		if (from == 'recommend')
			FN.native.setHead({
				url: 'recommend',
				title: '资金保障'
			});
		else
			FN.native.setHead({
				url: 'productDetail',
				title: '资金保障'
			});
		FN.native.setNavi({
			show: 0
		});
	}

	return {
		'init': init,
		'update': function() {
			setHeadAndNavi();
		}
	}
}).set('secureGoods', function(params) {
	var init = function(bill) {

		//show里面会读取,本地securePiaoJuZaiQuan.html内容替换显示
		FN.ctrl.show(params.ctrlName, bill);

		addObserver();

		setHeadAndNavi(bill.from);

		FN.native.closeWaitDialog();
	};

	var addObserver = function() {
		var pImgs = document.getElementsByClassName('protocolImgs_loadImg');

		for (var i = 0; i < pImgs.length; i++) {
			pImgs[i].addEventListener('load', function() {
				myScroll.refresh();
			});
		}
	}

	var setHeadAndNavi = function(from) {
		if (from == 'recommend')
			FN.native.setHead({
				url: 'recommend',
				title: '资金保障'
			});
		else
			FN.native.setHead({
				url: 'productDetail',
				title: '资金保障'
			});
		FN.native.setNavi({
			show: 0
		});
	}

	return {
		'init': init,
		'update': function() {
			setHeadAndNavi();
		}
	}
});